=begin
#-------------------------------
Author: Tax, 2021
License: [Free] [Opensource]

Description: 
Make mechanical parts (mariner and roller chain links, spur gears, springs, suspensions, bicycle wheels and railroad along path) based on specifications and other utilities.
Usage: Extensions/Tax_Engineering

Change log:
-
-
-
#-------------------------------
=end


#!/usr/bin/env ruby
require 'sketchup.rb'
require 'extensions.rb'

#-------------------------------------------------------------------------------
module Taxsola
	module Tax_Engineering
	PLUGIN_NAME = "Tax Engineering"

	@Min_Version = 17
	@Sket_Version = Sketchup.version.to_f

	@msg = ""
	@msg += "\n----------------------------------------\n"
	@msg += PLUGIN_NAME + "\n\n"
	@msg += "Current OS: " + Sketchup.platform.to_s + "\n"
	@msg += "Current SU version: " + @Sket_Version.to_s + "\n"
	@msg += "\n"
	@msg += "Supported OS: Windows and Mac(osx)\n"
	@msg += "Min SU version: " + @Min_Version.to_s + "\n"
	@msg += "\nInstallation error due to incompatibility.\n"
	@msg += "----------------------------------------\n"
	if (@Sket_Version < @Min_Version) || ((Sketchup.platform != :platform_win) && (Sketchup.platform != :platform_osx))
		UI.messagebox(@msg,MB_MULTILINE,"Tax Engineering (Installation error)")
		raise Exception.new(@msg)
	end

	# Plugin information
	PLUGIN_ID = File.basename(__FILE__, ".rb")
	PLUGIN_ROOT = File.dirname(__FILE__)
	PLUGIN_DIR = File.join( PLUGIN_ROOT, PLUGIN_ID )

		unless file_loaded?( __FILE__ )
		LOADER = File.join(PLUGIN_DIR, "Menus")
		EXTENSION = SketchupExtension.new( PLUGIN_NAME, LOADER )
		EXTENSION.creator     = "Tax"
		EXTENSION.description = "Along path features, mechanical parts, color harmony pallete +other utilities."
		EXTENSION.version     = "10.92" #UPDATE INFO <<<
		EXTENSION.copyright   = "#{EXTENSION.creator} 2020-2022"
		Sketchup.register_extension(EXTENSION, true)
		
		file_loaded( __FILE__ )
		end
	end
end
#-------------------------------------------------------------------------------