=begin
#-------------------------------
Author: Tax, 2021-2022
Description: Tax's Methods/Classes Library
#-------------------------------
=end


#-------------------------------------------------------------------------------
module Taxsola

#Converts any value to radians
def self.to_angle(input)
@String = input.to_s.tr(",",".")

	if @String.end_with?("radians") || @String.end_with?("rad")
		@Angle = @String.to_f #Leave it as is and will function as radians
	else
		@Angle = @String.to_f.degrees #converts from deg to rad
	end

return @Angle #Float radians output
end


#########################################################################

(
def self.classify_vertexes(edges)
#VERTEX TYPE CLASSIFICATION --------------------------------------------------
@Raw_vertexes = []
edges.each { |edge| @Raw_vertexes << edge.start; @Raw_vertexes << edge.end;}

@Single_vertexes = @Raw_vertexes.uniq
@Vertex_Counter = @Single_vertexes.collect { |v| @Raw_vertexes.count(v) }

@End_Vertexes = []
@Middle_Vertexes = [] 
@Intersection_Vertexes = []

@ID = 0
	@Vertex_Counter.each do |counter|
		if (counter == 1) then @End_Vertexes << @Single_vertexes[@ID]; end
		if (counter == 2) then @Middle_Vertexes << @Single_vertexes[@ID]; end
		if (counter > 2) then @Intersection_Vertexes << @Single_vertexes[@ID]; end
		@ID += 1
	end

@Classified_Vertexes = []
@Classified_Vertexes << @End_Vertexes << @Middle_Vertexes << @Intersection_Vertexes
return @Classified_Vertexes
#-----------------------------------------------------------------------------
end


def self.make_segment(initial_vertex, initial_edge, middle_vertexes)
@Curr_Seg = []
@Curr_Check_Edges = []
@Curr_Vertex = initial_vertex
@Curr_Edge = initial_edge

@Curr_Seg << @Curr_Vertex
@Curr_Vertex = @Curr_Edge.other_vertex @Curr_Vertex
@Curr_Check_Edges << @Curr_Edge
@Curr_Seg << @Curr_Vertex

	while (middle_vertexes.include?(@Curr_Vertex)) && (@Curr_Vertex != initial_vertex)
		@Curr_Edge = (@Curr_Vertex.edges & @@Edges) - [@Curr_Edge]
		@Curr_Edge = @Curr_Edge[0]
		@Curr_Vertex = @Curr_Edge.other_vertex @Curr_Vertex
		@Curr_Check_Edges << @Curr_Edge
		@Curr_Seg << @Curr_Vertex
	end

return [@Curr_Seg, @Curr_Check_Edges]
end


def self.remove_aligned(segments)
@Segments = segments
@Seg_Num = 0

	@Segments.each do |segment|

	@To_Remove = []
		for id in 1..(segment.length-2)
			@Curr_p = segment[id].position
			@Last_p = segment[id-1].position
			@Next_p = segment[id+1].position

			@Back_vec = @Curr_p.vector_to @Last_p
			@Front_vec = @Curr_p.vector_to @Next_p
			@Back_vec.normalize!
			@Front_vec.normalize!

			if (@Back_vec.reverse == @Front_vec) then @To_Remove << segment[id]; end
		end

	@Segments[@Seg_Num] = segment - @To_Remove
	@Seg_Num += 1
	end

return @Segments
end


def self.vertex_to_points(segments)
@Segments = segments
@New_Segments = []

	@Segments.each do |segment|
		@Seg_Points = []
		segment.each {|vertex| @Seg_Points << vertex.position}
		@New_Segments << @Seg_Points
	end

return @New_Segments
end


#General manager of segments making
def self.generate_segments(chaotic_edges)
@@Edges = chaotic_edges

#Vertex classification method
@End_Vertexes, @Middle_Vertexes, @Intersection_Vertexes = Taxsola.classify_vertexes(@@Edges)

@Segments = []
@Checked_Edges = []
@Unchecked_end_vertexes = @End_Vertexes
@Unchecked_middle_vertexes = @Middle_Vertexes

#SEGMENTS FROM INTERSECTIONS ----------------------------------
if (@Intersection_Vertexes.length > 0)

@Intersection_edges = []
@Intersection_Vertexes.each do |vertex|
	@Intersection_edges << vertex.edges & @@Edges
end

	for step in 0..(@Intersection_Vertexes.length-1)

	@Vertex = @Intersection_Vertexes[step]
	@I_Edges = @Intersection_edges[step]

		@I_Edges.each do |edge|
			if (!@Checked_Edges.include?(edge))
				@Segment, @Checked_Edges_Cache = Taxsola.make_segment(@Vertex, edge, @Middle_Vertexes)
				@Segments << @Segment
				@Unchecked_end_vertexes -= [@Segment.last]
				@Unchecked_middle_vertexes -= @Segment
				@Checked_Edges += @Checked_Edges_Cache
			end
		end
	end
end
#---------------------------------------------------------------


#SEGMENTS FROM ENDS ----------------------------------
while (@Unchecked_end_vertexes.length > 0)
@Vertex = @Unchecked_end_vertexes[0]
@End_edge = @Vertex.edges & @@Edges
@End_edge = @End_edge[0]

if (!@Checked_Edges.include?(@End_edge))
	@Segment, @Checked_Edges_Cache = Taxsola.make_segment(@Vertex, @End_edge, @Middle_Vertexes)
	@Segments << @Segment
	@Unchecked_end_vertexes -= [@Segment.last]
	@Unchecked_middle_vertexes -= @Segment
	@Checked_Edges += @Checked_Edges_Cache
end

@Unchecked_end_vertexes -= [@Vertex]
end
#-----------------------------------------------------


#SEGMENTS FROM ISOLATED LOOPS ------------------------
while (@Unchecked_middle_vertexes.length > 0)
@Vertex = @Unchecked_middle_vertexes[0]
@L_edge = @Vertex.edges & @@Edges
@L_edge = @L_edge[0]

if (!@Checked_Edges.include?(@L_edge))
	@Segment, @Checked_Edges_Cache = Taxsola.make_segment(@Vertex, @L_edge, @Middle_Vertexes)
	@Segments << @Segment
	@Unchecked_middle_vertexes -= @Segment
	@Checked_Edges += @Checked_Edges_Cache
end

@Unchecked_middle_vertexes -= [@Vertex]
end
#-----------------------------------------------------


#Remove aligned (in line) vertexes
@Segments = Taxsola.remove_aligned(@Segments)

#Convert vertexes to points
@Segments = Taxsola.vertex_to_points(@Segments)


return @Segments
end


def self.axial_flatten2(segments)
@Seg_X = []
@Seg_Y = []
@Seg_Z = []

	segments.each do |segment|
		segment.each do |point|
			@Seg_X << point[0]
			@Seg_Y << point[1]
			@Seg_Z << point[2]
		end
	end

@Max_X = @Seg_X.max
@Max_Y = @Seg_Y.max
@Max_Z = @Seg_Z.max

@Min_X = @Seg_X.min
@Min_Y = @Seg_Y.min
@Min_Z = @Seg_Z.min

@Delta_X = @Max_X - @Min_X
@Delta_Y = @Max_Y - @Min_Y
@Delta_Z = @Max_Z - @Min_Z

@Deltas = []
@Deltas << @Delta_X << @Delta_Y << @Delta_Z

@Min_Var_Axis = @Deltas.index(@Deltas.min) #0, 1, 2 (X, Y, Z)
@Flat_coord = segments[0][0][@Min_Var_Axis]


#Converting 3d points to array
@Segments = []
segments.each do |seg|
	@Segment = []
	seg.each do |point|
		@Segment << point.to_a
	end
@Segments << @Segment
end


#Flatting and preventing overlap issues
@To_delete = []
	for seg in 0..(@Segments.length-1)
		@Seg = @Segments[seg]
		if (@Seg.first == @Seg.last) then @mode = "loop"; else @mode = "open"; end

		for point in 0..(@Seg.length-1)
			@Segments[seg][point][@Min_Var_Axis] = @Flat_coord
		end

		@Segments[seg].uniq!
		if (@mode == "loop") then @Segments[seg] << @Seg.first end
		if (@Segments[seg].length < 2) then @To_delete << @Segments[seg]; end
	end
@Segments -= @To_delete


#Converting array back to 3d points
@Segs = []
@Segments.each do |seg|
	@Seg = []
	seg.each do |pt|
		@Seg << Geom::Point3d.new(pt)
	end
@Segs << @Seg
end


return [@Segs, @Min_Var_Axis]
end
)

#########################################################################

(
#Angled offset math
def self.find_new_point(current_point, reference_point, next_point, interval)
#Vectors
@Back_Vec = (reference_point.vector_to(current_point))
@Front_Vec = (reference_point.vector_to(next_point))

#Math
@Angle_A = @Back_Vec.angle_between @Front_Vec
@Angle_B = (Math.asin((Math.sin(@Angle_A)*@Back_Vec.length)/interval))
@Angle_C = (180.0 - (@Angle_A.radians + @Angle_B.radians)).degrees
@Ref_Offset = (Math.sin(@Angle_C)*interval)/Math.sin(@Angle_A)

#Final result
@Front_Vec.length = @Ref_Offset
@New_Point = reference_point.offset(@Front_Vec)

return @New_Point
end


def self.collinear_check(point1, point2, point3)
	@Array = [point1, point2, point3].uniq
	if (@Array.length == 2) then return true end
	@Vector1 = point1.vector_to(point2)
	@Vector2 = point1.vector_to(point3)
	@Vector1.normalize!
	@Vector2.normalize!
	if (@Vector1 == @Vector2) || (@Vector1 == @Vector2.reverse) then return true end
	return false
end


def self.distance(pointA, pointB)
@PTAx = BigDecimal(pointA[0].to_f.to_s, 16)
@PTAy = BigDecimal(pointA[1].to_f.to_s, 16)
@PTAz = BigDecimal(pointA[2].to_f.to_s, 16)

@PTBx = BigDecimal(pointB[0].to_f.to_s, 16)
@PTBy = BigDecimal(pointB[1].to_f.to_s, 16)
@PTBz = BigDecimal(pointB[2].to_f.to_s, 16)

@Dx = @PTBx - @PTAx
@Dy = @PTBy - @PTAy
@Dz = @PTBz - @PTAz

@Dist = BigMath.sqrt((@Dx*@Dx)+(@Dy*@Dy)+(@Dz*@Dz), 16)
return @Dist.to_f
end



def self.normalize_segments2(segments, compass, reverse)

@Normalized_Segments = []

segments.each do |segment|
	@Current_Point = segment[0]
	@Next_Point = segment[1]

	@Normalized_Segment = []
	@Normalized_Segment << Geom::Point3d.new(@Current_Point)

	@STATUS = "STARTING"
	until (@STATUS == "FINISHED")
		@Distance = Taxsola.distance(@Current_Point, @Next_Point)

		until (@Distance >= compass.to_f) || ( segment.index(@Next_Point) == (segment.length-1) ) || ( segment.index(@Next_Point) == 0 )
		@Next_Point = segment[segment.index(@Next_Point)+1]
		@Distance = Taxsola.distance(@Current_Point, @Next_Point)
		end

		if (compass.to_f > @Distance) then
			#Last point
			@New_Point = @Next_Point
			
			#edited in 05/13/22 - found a glitch on linear test where it register end point twice and so causes a normal vector of 0
			if (@Distance != 0) then @Normalized_Segment << Geom::Point3d.new(@New_Point); end

			@STATUS = "FINISHED"
		end

		if (compass.to_f < @Distance)
			if Taxsola.collinear_check(@Current_Point, segment[segment.index(@Next_Point)-1], @Next_Point)
				#Linear
				@New_Point_Offset = @Current_Point.vector_to(@Next_Point)
				@New_Point_Offset.length = compass.to_f
				@New_Point = @Current_Point.offset(@New_Point_Offset)
				@Normalized_Segment << Geom::Point3d.new(@New_Point)

				@Current_Point = @New_Point
			else
				#Angular
				@New_Point = Taxsola.find_new_point(@Current_Point, segment[segment.index(@Next_Point)-1], @Next_Point, compass.to_f)
				@Normalized_Segment << Geom::Point3d.new(@New_Point)

				@Current_Point = @New_Point
			end
		end

		if (compass == @Distance) && (@STATUS != "FINISHED")
			@New_Point = @Next_Point
			@Normalized_Segment << Geom::Point3d.new(@New_Point)

			@Current_Point = @New_Point
			
			if (segment.index(@Next_Point) == (segment.length-1)) then @STATUS = "FINISHED"; end
		end
	end #end of until finished segment

	if (reverse == "Yes")
		@Normalized_Segments << @Normalized_Segment.reverse
	else
		@Normalized_Segments << @Normalized_Segment
	end
end #end of normalizing segments


return @Normalized_Segments
end #end of method
)

#########################################################################

(
def self.find_normal(point1, point2, point3) #Usually (lastpoint, currentpoint, nextpoint)
	if point3 == "" then return (point1.vector_to(point2)).normalize! end

@Last_Vec = (point1.vector_to(point2)).normalize!
@Next_Vec = (point2.vector_to(point3)).normalize!
@Normal = Geom::Vector3d.linear_combination(0.5, @Last_Vec, 0.5, @Next_Vec)
return @Normal.normalize!
end

#########################################################################

def self.unitary_scale(minimmum, current, maximum)
	if (maximum <= minimmum) then return 0 end
@Spectrum = maximum.to_f - minimmum.to_f
@Curr = current.to_f - minimmum.to_f
@Value = @Curr/@Spectrum

return @Value #0 to 1
end


def self.truncate_vector(vector)
case vector
	when -> (v) { (v.angle_between Z_AXIS).radians < 45 }
		@Truncated = Z_AXIS
	when -> (v) { (v.angle_between Z_AXIS.reverse).radians < 45 }
		@Truncated = Z_AXIS.reverse

	when -> (v) { (v.angle_between X_AXIS).radians < 45 }
		@Truncated = X_AXIS
	when -> (v) { (v.angle_between X_AXIS.reverse).radians < 45 }
		@Truncated = X_AXIS.reverse

	when -> (v) { (v.angle_between Y_AXIS).radians < 45 }
		@Truncated = Y_AXIS
	when -> (v) { (v.angle_between Y_AXIS.reverse).radians < 45 }
		@Truncated = Y_AXIS.reverse

	else
		@Truncated = vector.normalize
end

return @Truncated
end
)


#########################################################################
(#THIS IS A NOTIFICATION SYSTEM.
#THANKS TO S.WILLIAMS TO MAKE IT POSSIBLE.
#27/11/2022

#Class Notification is an HtmlDialog that knows how to close itself after timeout seconds
class Notification
	attr_reader :notif_box

	def initialize( params, html )  
		@notif_box = UI::HtmlDialog.new( params )
		@notif_box.set_html( html )
		@notif_box.set_size( 400, 100 )
		@notif_box.set_position(8,10)

		@notif_box.show
		
		#Success sound
		@Settings_data = Taxsola.check_settings()
		if (@Settings_data['notification_sound']) then Taxsola.soundeffect(2); end #2: Notification
		
		sleep 1
		
		@Settings_data = Taxsola.check_settings()
		UI.start_timer( @Settings_data['notif_timeout'].to_f, false ) { @notif_box.close }
	end #initialize

end #notification



#For flexibility the HTML content and actions are setup by the calling method.
def self.notif(title, message, label1, label2, url)  
	@params = {
		:dialog_title => title.to_s,
		:preferences_key => "com.sample.plugin",
		:resizable => false,
		:style => UI::HtmlDialog::STYLE_DIALOG
	}

	include Tax_Engineering
	@html = "<!DOCTYPE html>
	  <html>
		"+@@HtmlDialog_Dependencies+"
		<script>function Input(val) {sketchup.Input(val);}</script>
		<body>

		<div class='modal-content' style='height: 100%; border-style: none;'><div class='modal-footer'>
		  <h5 id='a' style='position: absolute; top: 15px; left: 10px;'>" + message.to_s + "</h5><br>
		  <button type='button' class='btn btn-sm btn-outline-dark' onclick='Input(0);'>" + label1.to_s + "</button>
		  <button type='button' class='btn btn-sm btn-primary' onclick='Input(1)'>" + label2.to_s + "</button>
		</div></div>
		</body>
	  </html>"
	
	# create and show the dialog
	@notif_object = Taxsola::Notification.new( @params, @html )

	# add callback routines
	@notif_object.notif_box.add_action_callback("Input") { |action_context, x|
		case x
		when 0
			include Tax_Engineering
			Tax_Engineering.settings
		when 1
			UI.openURL(url)
		end
		@notif_object.notif_box.close
	}
end #method


def self.process_body(body)
	@v_ind1 = "<b>Version: </b>"
	@v_ind2 = "</p><p><b>Categories: </b>"

	@v_start = body.index(@v_ind1)+(@v_ind1.length)
	@v_end = body.index(@v_ind2)

	@version = body[@v_start, @v_end-@v_start]

	#-----------------------------------------------------

	@u_ind1 = "v" + @version + " - "
	@u_ind2 = "<br>"

	@u_start = body.index(@u_ind1)+(@u_ind1.length)
	@u_end = (body[@u_start,body.length]).index(@u_ind2)

	@update = body[@u_start, @u_end].to_s

	return @version, @update
end


def self.update_check(current_version, weblink, mode)
	p "-------------------------------"
	p "TAX Engineering - update check."
	p "Starting connection."

	@request = Sketchup::Http::Request.new(weblink, Sketchup::Http::GET)
	@request.start do |request, response|

		if (@request.status) == 1
			p "Connection success."

			@version, @update = Taxsola.process_body("#{response.body}") #Web Scrapping

			p "Check is finished."
			p "Version: " + @version
			p "Update: " + @update
			
			if (@version.to_f > current_version.to_f)
				p "New update is available."
				@title = "TAX - notification"
				@announce = "Tax Engineering v"+@version+" is available!"
				
				if (mode == "start")
					#(title, message, label1, label2, weblink)
					Taxsola.notif( @title, @announce, "Settings", "View", weblink)
				else
					if UI.messagebox(@announce+"\nUpdate: "+@update.to_s+"\n\nGo to website?" , type = MB_YESNO) == IDYES
						UI.openURL(weblink)
					end
				end
			else
				if (mode != "start") then UI.messagebox("Already got last update.", type = MB_OK); end
				p "Already got last update."
			end

		else
			if (mode != "start") then UI.messagebox("Failed to connect.", type = MB_OK); end
			p "Failed to connect."
		end

	p "-------------------------------"
	end
end
#########################################################################
)


#CUSTOM SOUND EFFECTS SYSTEM
def self.soundeffect(use)
	
	@Settings_data = Taxsola.check_settings()

	include Tax_Engineering
	case use
		when 0 #Installation
			UI.play_sound(@@Menus_Path.to_s + "/Dependencies/Sounds/Installation.wav");
		when 1 #Success
			if (@Settings_data['success_sound']) then UI.play_sound(@@Menus_Path.to_s + "/Dependencies/Sounds/Sucess.wav"); end
		when 2 #Notification
			if (@Settings_data['notification_sound']) then UI.play_sound(@@Menus_Path.to_s + "/Dependencies/Sounds/Notification.wav"); end
		when 3 #Vray_Alarm
			UI.play_sound(@@Menus_Path.to_s + "/Dependencies/Sounds/Vray_Alarm.wav");
		else
		  p "TAX - SoundEffect use is not registered."
	end
end



#SETTINGS ###############################################################
#USAGE:
#@Settings_data = Taxsola.check_settings()
#@Settings_data['KEY']="VALUE";
#Taxsola.write_settings(@Settings_data)

#CHECK SETTINGS FILE AND RETURNS A HASH OF ITS DATA
def self.check_settings()
	include Tax_Engineering
	
	if not(File.file?(@@Settings_Path))
		@msg = "Tax - error: Settings file couldn't be found."
		UI.messagebox(@msg)
		raise Exception.new(@msg)
	end
	
	@Settings_file = File.open(@@Settings_Path)
	@Settings_data = JSON.load @Settings_file #Read settings json file
	@Settings_file.close
	
	return @Settings_data
end

#WRITE TO SETTINGS FILE
def self.write_settings(settings_data)
	include Tax_Engineering
	File.write(@@Settings_Path, JSON.dump(settings_data))
end
#########################################################################


end #end of Taxsola library module
#-------------------------------------------------------------------------------