=begin
#-------------------------------
Author: Tax, 2021
Description:
#-------------------------------
=end


#-------------------------------------------------------------------------------
module Taxsola
	module Tax_Engineering

def self.adjustable_suspension_dialog
#-------------------------------------------------------------------------------
@Detail = 24
@Spring_Revolution_Detail = 24
@Spring_Tube_Detail = 12
@Suspension_Length = 500.00.mm
@Suspension_Extension = 50.00
@Spring_Compression = 10.00
@Cilinder_Diameter = 20.00.mm
@Casing_Thickness = 25.00.mm
@Casing_Screw_Laps = 50
@Plate_Thickness = 20.00.mm
@Compressor_Thickness = 25.00.mm
@Hole_Diameter = 20.00.mm
@End_Elongation = 15.00.mm
@Anchor_Thickness = 15.00.mm
@Spring_Revolutions = 10
@Spring_Tube_Diameter = 15.00.mm
@MakeRef = "No"

@Verification = "NOT OK"
until @Verification == "OK"
#-------------------------------------------------------------------------------
@Verification = "OK"
prompts = ["General detail: ", "Spring revolution detail: ", "Spring tube detail: ", "Suspension length: ", "Suspension extension (0-100)%: ", "Spring compression (0-95)%: ", "Cilinder diameter: ", "Casing thickness: ", "Casing screw laps: ", "Plate thickness: ", "Compressor thickness: ", "Hole diameter: ", "End elongation: ", "Anchor thickness: ", "Spring revolutions: ", "Spring tube diameter: ", "Make references: "]
defaults = [@Detail, @Spring_Revolution_Detail, @Spring_Tube_Detail, @Suspension_Length, @Suspension_Extension, @Spring_Compression, @Cilinder_Diameter, @Casing_Thickness, @Casing_Screw_Laps, @Plate_Thickness, @Compressor_Thickness, @Hole_Diameter, @End_Elongation, @Anchor_Thickness, @Spring_Revolutions, @Spring_Tube_Diameter, @MakeRef]
list = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "Yes|No"]

val = UI.inputbox(prompts, defaults, list, "Make Adjustable Suspension")
if val
@Detail, @Spring_Revolution_Detail, @Spring_Tube_Detail, @Suspension_Length, @Suspension_Extension, @Spring_Compression, @Cilinder_Diameter, @Casing_Thickness, @Casing_Screw_Laps, @Plate_Thickness, @Compressor_Thickness, @Hole_Diameter, @End_Elongation, @Anchor_Thickness, @Spring_Revolutions, @Spring_Tube_Diameter, @MakeRef = val;
else
	raise Exception.new("Make Adjustable Suspension error: ASxV.000 - Operation canceled.")
end
#-------------------------------------------------------------------------------

#Log and verification
print 'Make Adjustable Suspension operation:'
print 'Input log: ' + val[0].to_s + ' | ' + val[1].to_s + ' | ' + val[2].to_s + ' | ' + val[3].to_s + ' | ' + val[4].to_s + ' | ' + val[5].to_s + ' | ' + val[6].to_s + ' | ' + val[7].to_s + ' | ' + val[8].to_s + ' | ' + val[9].to_s + ' | ' + val[10].to_s + ' | ' + val[11].to_s + ' | ' + val[12].to_s + ' | ' + val[13].to_s + ' | ' + val[14].to_s + ' | ' + val[15].to_s + ' | ' + val[16].to_s

print 'Make Adjustable Suspension - Debug point 1/7 ok'

(#VERIFICATIONS


#Detail < 6
if (@Detail < 6)
UI.messagebox("error: ASxV.001 - Min general detail is 6.")
warn("Make Parts error: ASxV.001")
@Verification = "NOT OK"
end

#Detail < 6
if (@Spring_Revolution_Detail < 6)
UI.messagebox("error: ASxV.002 - Min spring revolution detail is 6.")
warn("Make Parts error: ASxV.002")
@Verification = "NOT OK"
end

#Detail < 6
if (@Spring_Tube_Detail < 6)
UI.messagebox("error: ASxV.003 - Min spring tube detail is 6.")
warn("Make Parts error: ASxV.003")
@Verification = "NOT OK"
end

#Suspension_Length > 0
if (@Suspension_Length <= 0)
UI.messagebox("error: ASxV.004 - Suspension length must be higher than 0.")
warn("Make Parts error: ASxV.004")
@Verification = "NOT OK"
end

#0 < Suspension_Extension > 100
if (@Suspension_Extension < 0) or (@Suspension_Extension > 100)
UI.messagebox("error: ASxV.005 - Suspension extension must be in range (0-100).")
warn("Make Parts error: ASxV.005")
@Verification = "NOT OK"
end

#0 < Spring_Compression > 95
if (@Spring_Compression < 0) or (@Spring_Compression > 95)
UI.messagebox("error: ASxV.006- Suspension extension must be in range (0-95).")
warn("Make Parts error: ASxV.006")
@Verification = "NOT OK"
end

#Cilinder_Diameter > 0
if (@Cilinder_Diameter <= 0)
UI.messagebox("error: ASxV.007 - Cilinder diameter must be higher than 0.")
warn("Make Parts error: ASxV.007")
@Verification = "NOT OK"
end

#Casing_Thickness > 0
if (@Casing_Thickness <= 0)
UI.messagebox("error: ASxV.008 - Casing thickness must be higher than 0.")
warn("Make Parts error: ASxV.008")
@Verification = "NOT OK"
end

#@Plate_Thickness limit
if (@Plate_Thickness <= 0)
UI.messagebox("error: ASxV.009 - Plate thickness must be higher than 0.")
warn("Make Parts error: ASxV.009")
@Verification = "NOT OK"
end

#@Plate_Thickness limit
if (@Plate_Thickness > @Suspension_Length/4)
UI.messagebox("error: ASxV.010 - Plate thickness is too high.")
warn("Make Parts error: ASxV.010")
@Verification = "NOT OK"
end

#@Compressor_Thickness limit
if (@Compressor_Thickness <= 0)
UI.messagebox("error: ASxV.0011 - Compressor thickness must be higher than 0.")
warn("Make Parts error: ASxV.0011")
@Verification = "NOT OK"
end

#@Compressor_Thickness limit
if (@Compressor_Thickness > @Suspension_Length/4)
UI.messagebox("error: ASxV.012 - Compressor thickness is too high.")
warn("Make Parts error: ASxV.012")
@Verification = "NOT OK"
end

#@End_Elongation limit
if (@End_Elongation < 0)
UI.messagebox("error: ASxV.013 - End elongation can't be negative.")
warn("Make Parts error: ASxV.013")
@Verification = "NOT OK"
end

#@End_Elongation limit
if (@End_Elongation > @Suspension_Length/4)
UI.messagebox("error: ASxV.014 - End elongation is too high.")
warn("Make Parts error: ASxV.014")
@Verification = "NOT OK"
end

#@Hole_Diameter min
if (@Hole_Diameter <= 0)
UI.messagebox("error: ASxV.015 - Hole diameter must be higher than 0.")
warn("Make Parts error: ASxV.015")
@Verification = "NOT OK"
end

#@Anchor_Thickness min
if (@Anchor_Thickness <= 0)
UI.messagebox("error: ASxV.016 - Anchor thickness must be higher than 0.")
warn("Make Parts error: ASxV.016")
@Verification = "NOT OK"
end

#@Hole_Diameter limit
if (@Hole_Diameter >= (@Cilinder_Diameter + 2*@Casing_Thickness) )
UI.messagebox("error: ASxV.017 - Hole diameter or Anchor thickness is too large.")
warn("Make Parts error: ASxV.017")
@Verification = "NOT OK"
end

#Casing_Screw_Laps min
if (@Casing_Screw_Laps <= 0)
UI.messagebox("error: ASxV.018 - Casing screw laps must be higher than 0.")
warn("Make Parts error: ASxV.018")
@Verification = "NOT OK"
end

#@Spring_Revolutions min
if (@Spring_Revolutions <= 0)
UI.messagebox("error: ASxV.019 - Spring revolutions must be higher than 0.")
warn("Make Parts error: ASxV.019")
@Verification = "NOT OK"
end

#@Spring_Tube_Diameter min
if (@Spring_Tube_Diameter <= 0)
UI.messagebox("error: ASxV.020 - Spring tube diameter must be higher than 0.")
warn("Make Parts error: ASxV.020")
@Verification = "NOT OK"
end
)

end

#-------------------------------------------------------------------------------
print 'Make Adjustable Suspension - Debug point 2/7 ok'
UI.messagebox("It can take a few minutes, please wait.")
#Timer start
@start_time = Time.now

(#CAMERA AND BOOST --------------------------------------------------------------------

#Define camera view
camera = Sketchup::Camera.new([15, -15, 15], [0, 0, 0], Z_AXIS)
view = Sketchup.active_model.active_view
view.camera = camera

#Speed boost by disable UI updates
model = Sketchup.active_model
entities = model.active_entities
model.start_operation('Make Parts', true)

#-------------------------------------------------------------------------------
)

(#Suspension --------------------------------------------------------------------------
model = Sketchup.active_model
entities = model.active_entities
@Suspension = Sketchup.active_model.entities.add_group
@Structure = @Suspension.entities.add_group
@Spring = @Suspension.entities.add_group
@Reference = @Suspension.entities.add_group


#Generic Variables
@Scale = 10000.00

@Spring_Color = [200, 40, 40]
@Cilinder_Color = [178,191,209]
@Casing_Color = [30,30,30]
@Compressor_Color = [100,20,20]
@End_Color = [80,80,80]


#Suspension Variables
@Suspension_Length = (@Suspension_Length * @Scale).to_f
@Suspension_Extension = (@Suspension_Extension).to_f
@Spring_Compression = (@Spring_Compression).to_f

@Cilinder_Diameter = (@Cilinder_Diameter * @Scale).to_f
@Casing_Thickness = (@Casing_Thickness * @Scale).to_f
@Casing_Screw_Laps = (@Casing_Screw_Laps).to_i
@Plates_Radius = 0.00
@Plate_Thickness = (@Plate_Thickness * @Scale).to_f
@Compressor_Thickness = (@Compressor_Thickness * @Scale).to_f
@Anchor_Thickness = (@Anchor_Thickness * @Scale).to_f
@Hole_Diameter = (@Hole_Diameter * @Scale).to_f
@End_Elongation = (@End_Elongation * @Scale).to_f


#Spring Variables
@Spring_Radius = 0.00
@Spring_Length = 0.00

@Spring_Revolutions = (@Spring_Revolutions).to_i
@Spring_Revolution_Detail = (@Spring_Revolution_Detail).to_i

@Spring_Tube_Diameter = (@Spring_Tube_Diameter * @Scale).to_f
@Spring_Tube_Detail = (@Spring_Tube_Detail).to_i

@MakeRef = @MakeRef.to_s
@Spring_Reference = "No"
#--------------------------------------------------------------------------
)

(#Initial MATH
@Inside_Range = @Suspension_Length - (@Hole_Diameter + 2*@Anchor_Thickness + 2*@End_Elongation + 2*@Plate_Thickness)
@Half_Range = @Inside_Range/2

@Cilinder_Length = ((1.00 - (@Suspension_Extension/100.00)) * @Half_Range) +@Half_Range
@Casing_Length = @Cilinder_Length

@Compression_Range = (1.00 - (@Spring_Compression/100.00)) * (@Casing_Length - @Compressor_Thickness)
@Spring_Length = @Inside_Range - (@Casing_Length - @Compression_Range)

#VERIFICATION ---------------------------------- MAX @Spring_Tube_Diameter
if (@Spring_Tube_Diameter > (@Spring_Length / @Spring_Revolutions)/2 )
UI.messagebox("error: ASxV.021 - Spring tube diameter is too large.")
raise Exception.new("Make Parts error: ASxV.021")
end
#-------------------------------------------------------------------------

@Casing_Out_Radius = (@Cilinder_Diameter/2) + @Casing_Thickness
@Plates_Radius = @Casing_Out_Radius + (@Spring_Tube_Diameter * 1.5)

@Spring_Radius = @Casing_Out_Radius + (@Spring_Tube_Diameter/2)
#--------------------------------------------------------------------------
)

(#References
@Half_Susp_Length = (@Suspension_Length/2)
@Center_Point = @Reference.entities.add_cpoint [0,0,0]
@Top_Hole_Center = @Reference.entities.add_cpoint [0,0,@Half_Susp_Length]
@Bottom_Hole_Center = @Reference.entities.add_cpoint [0,0,-@Half_Susp_Length]

@Length_Line = @Reference.entities.add_line [0, 0, @Half_Susp_Length], [0, 0, -@Half_Susp_Length]
@Anchor_Line1 = @Reference.entities.add_line [0, @Half_Susp_Length, @Half_Susp_Length], [0, -@Half_Susp_Length, @Half_Susp_Length]
@Anchor_Line2 = @Reference.entities.add_line [0, @Half_Susp_Length, -@Half_Susp_Length], [0, -@Half_Susp_Length, -@Half_Susp_Length]

@Ref_Top_Hole = @Reference.entities.add_circle([0,0,@Half_Susp_Length], [0, 1, 0] , @Hole_Diameter/2, @Detail)
@Ref_Bottom_Hole = @Reference.entities.add_circle([0,0,-@Half_Susp_Length], [0, 1, 0] , @Hole_Diameter/2, @Detail)

@Plate_Offset = (@Hole_Diameter/2 + @Anchor_Thickness + @End_Elongation)
@Ref_Top_Plate = @Reference.entities.add_circle([0,0, (@Half_Susp_Length-@Plate_Offset)], [0, 0, 1] , @Plates_Radius, @Detail)
@Ref_Bottom_Plate = @Reference.entities.add_circle([0,0, -(@Half_Susp_Length-@Plate_Offset)], [0, 0, 1] , @Plates_Radius, @Detail)

@Ref_Cilinder1 = @Reference.entities.add_circle([0,0, @Half_Range], [0, 0, 1] , @Cilinder_Diameter/2, @Detail)
@Ref_Cilinder2 = @Reference.entities.add_circle([0,0, @Half_Range-@Cilinder_Length], [0, 0, 1] , @Cilinder_Diameter/2, @Detail)

@Ref_Casing1 = @Reference.entities.add_circle([0,0, -@Half_Range], [0, 0, 1] , @Casing_Out_Radius, @Detail)
@Ref_Casing2 = @Reference.entities.add_circle([0,0, (-@Half_Range+@Casing_Length)], [0, 0, 1] , @Casing_Out_Radius, @Detail)

@Ref_Compressor = @Reference.entities.add_circle([0,0, (-@Half_Range+@Casing_Length-@Compression_Range)], [0, 0, 1] , @Plates_Radius, @Detail)

@Spring_ZPosition = @Half_Range - (@Spring_Length/2)
@Spring_Center_Point = @Reference.entities.add_cpoint [0,0,@Spring_ZPosition]
@Spring_Ref_Radius = @Reference.entities.add_circle([0,0,@Spring_ZPosition], [0, 0, 1] , @Spring_Radius, @Detail)
#--------------------------------------------------------------------------

#Spring Reference
@SReference = @Reference.entities.add_group

#Defining parameters
@TotalEdges = @Spring_Revolutions * @Spring_Revolution_Detail
@Zincrement = @Spring_Length / @TotalEdges #Pico = media * pi/2

@ZincrementMed = @Spring_Length / @TotalEdges
@ZincrementMax = @ZincrementMed * (Math::PI/2)
@ParaboleUnit = (180.00 / @TotalEdges).degrees

@EdgeAngle = 360.00.degrees / @Spring_Revolution_Detail
@LapHeight = @Spring_Length / @Spring_Revolutions
@Spring_Start_Height = (-@Half_Range+@Casing_Length-@Compression_Range)

 #Make path reference
 @point1 = [@Spring_Radius, 0, @Spring_Start_Height]
 for step in 0..@TotalEdges
  @x = Math.cos(@EdgeAngle * step) * @Spring_Radius
  @y = Math.sin(@EdgeAngle * step) * @Spring_Radius

  @Zincrement = Math.sin(step * @ParaboleUnit) * @ZincrementMax
  @z = @point1.z + @Zincrement

  @point2 = [@x, @y, @z]
  @line = @SReference.entities.add_line @point1, @point2
  @point1 = @point2
 end
#--------------------------------------------------------------------------
)

print 'Make Adjustable Suspension - Debug point 3/7 ok'

(#Make spring tube

#Get edge and path reference
@RefEdge = @SReference.entities[0]
@Vector = @RefEdge.start.position.vector_to(@RefEdge.end.position)
@Path = @RefEdge.all_connected

#Make tube face
@Spring_Tube_Circle = @Spring.entities.add_circle(@RefEdge.start.position, @Vector , @Spring_Tube_Diameter/2, @Spring_Tube_Detail)
@Spring_Tube_Face = @Spring.entities.add_face(@Spring_Tube_Circle)

#-------------------------------------------------------------------------------

#Set face direction
@D = 3
@VectorModule = ((@Vector.x**2) + (@Vector.y**2) + (@Vector.z**2))**0.5
@UnitVector = [ (@Vector.x/@VectorModule).round(@D), (@Vector.y/@VectorModule).round(@D), (@Vector.z/@VectorModule).round(@D) ]

@FaceVectorModule = ((@Spring_Tube_Face.normal.x**2) + (@Spring_Tube_Face.normal.y**2) + (@Spring_Tube_Face.normal.z**2))**0.5
@FaceUnitVector = [ (@Spring_Tube_Face.normal.x/@FaceVectorModule).round(@D), (@Spring_Tube_Face.normal.y/@FaceVectorModule).round(@D), (@Spring_Tube_Face.normal.z/@FaceVectorModule).round(@D) ]

if @UnitVector == @FaceUnitVector
@Spring_Tube_Face.reverse!
end

#-------------------------------------------------------------------------------

#Apply face color
@Spring_Tube_Face.material = @Spring_Color
@Spring_Tube_Face.back_material = @Spring_Color

#Make tube
@Spring = @Spring_Tube_Face.followme(@Path)
)

#--------------------------------------------------------------------------------------

#MODELING
model = Sketchup.active_model
entities = model.active_entities

(# CILINDER----------------------------------------------------------------------
@Cilinder = @Structure.entities.add_group

@Cilinder_Circle = @Cilinder.entities.add_circle([0,0, @Half_Range], [0, 0, 1] , @Cilinder_Diameter/2, @Detail)
@Cilinder_Face = @Cilinder.entities.add_face(@Cilinder_Circle)
if @Cilinder_Face.normal.z == 1
@Cilinder_Face.reverse!
end

#Apply face color
@Cilinder_Face.material = @Cilinder_Color
@Cilinder_Face.back_material = @Cilinder_Color

@Cilinder_Face.pushpull(@Cilinder_Length, true)
)

print 'Make Adjustable Suspension - Debug point 4/7 ok'

(# CASING------------------------------------------------------------------------
@Casing = @Structure.entities.add_group
@Casing_Bevel = @Casing_Thickness/4

@Casing_Circle1 = @Casing.entities.add_circle([0,0, -@Half_Range], [0, 0, 1] , @Cilinder_Diameter/2, @Detail)
@Casing_Circle2 = @Casing.entities.add_circle([0,0, -@Half_Range], [0, 0, 1] , @Casing_Out_Radius, @Detail)

@Casing_Face1 = @Casing.entities.add_face(@Casing_Circle1)
@Casing_Face2 = @Casing.entities.add_face(@Casing_Circle2)
@Casing_Face1.erase!

if @Casing_Face2.normal.z == -1
@Casing_Face2.reverse!
end

#Apply face color
@Casing_Face2.material = @Casing_Color
@Casing_Face2.back_material = @Casing_Color

@Casing_Face2.pushpull(@Casing_Length-@Casing_Bevel, true)

@Casing_Circle3 = @Casing.entities.add_circle([0,0, -@Half_Range+@Casing_Length-@Casing_Bevel], [0, 0, 1] , @Cilinder_Diameter/2, @Detail)
@Casing_Circle4 = @Casing.entities.add_circle([0,0, -@Half_Range+@Casing_Length-@Casing_Bevel], [0, 0, 1] , @Cilinder_Diameter/2+@Casing_Bevel, @Detail)
@Casing_Circle42 = @Casing.entities.add_circle([0,0, -@Half_Range+@Casing_Length-@Casing_Bevel], [0, 0, 1] , @Cilinder_Diameter/2+(@Casing_Bevel*1.2), @Detail)

@Casing_Circle5 = @Casing.entities.add_circle([0,0, -@Half_Range+@Casing_Length-@Casing_Bevel], [0, 0, 1] , @Casing_Out_Radius, @Detail)
@Casing_Circle6 = @Casing.entities.add_circle([0,0, -@Half_Range+@Casing_Length-@Casing_Bevel], [0, 0, 1] , @Casing_Out_Radius-@Casing_Bevel, @Detail)


Sketchup.active_model.selection.clear
Sketchup.active_model.selection.add(@Casing_Circle3)
Sketchup.active_model.selection.add(@Casing_Circle4)

transform = Geom::Transformation.new([ 0, 0, @Casing_Bevel ])
@Casing.entities.transform_entities(transform, @Casing_Circle3)
@Casing.entities.transform_entities(transform, @Casing_Circle4)


Sketchup.active_model.selection.clear
Sketchup.active_model.selection.add(@Casing_Circle5)

transform = Geom::Transformation.new([ 0, 0, -@Casing_Bevel ])
@Casing.entities.transform_entities(transform, @Casing_Circle5)

@Casing.material = @Casing_Color



#--------------------------------------------------------------------------
#Screw_to_Subtract Reference

model = Sketchup.active_model
entities = model.active_entities
@Screw_to_Subtract_Path = @Structure.entities.add_group
@Screw_to_Subtract_Tube = @Structure.entities.add_group

   #Defining variables
   @Initial_Height = -@Half_Range
   @TotalEdges = @Casing_Screw_Laps * @Detail
   @Zincrement = @Casing_Length / @TotalEdges
   @EdgeAngle = 360.00.degrees / @Detail
   @Lap_Height = @Casing_Length / @Casing_Screw_Laps

    #Make path reference
    @point1 = [@Casing_Out_Radius, 0, @Initial_Height]
    for step in 0..@TotalEdges
     @x = Math.cos(@EdgeAngle * step) * @Casing_Out_Radius
     @y = Math.sin(@EdgeAngle * step) * @Casing_Out_Radius
     @z = @Initial_Height + (step * @Zincrement)
     @point2 = [@x, @y, @z]
     @line = @Screw_to_Subtract_Path.entities.add_line @point1, @point2
     @point1 = @point2
    end
    
   #Get edge and path reference
   @RefEdge = @Screw_to_Subtract_Path.entities[0]
   @Vector = @RefEdge.start.position.vector_to(@RefEdge.end.position)
   @Path = @RefEdge.all_connected

   #Make tube face
   if ( (@Lap_Height/4) > (@Casing_Thickness/3) )
    @Screw_Tube_Radius = (@Casing_Thickness/3)
   else
    @Screw_Tube_Radius = (@Lap_Height/4)
   end 
   
   @Screw_Detail = (@Detail/12) + 3
   @C1 = @Screw_to_Subtract_Tube.entities.add_circle(@RefEdge.start.position, @Vector , @Screw_Tube_Radius, @Screw_Detail.to_i)
   @F1 = @Screw_to_Subtract_Tube.entities.add_face(@C1)
   @F1.followme(@Path)
   @Screw_to_Subtract_Path.erase!
   
   @Casing = @Screw_to_Subtract_Tube.subtract(@Casing)
   
   @Casing.material = @Casing_Color
#--------------------------------------------------------------------------

)

print 'Make Adjustable Suspension - Debug point 5/7 ok'

(# ENDS--------------------------------------------------------------------------
@End = @Structure.entities.add_group
@Plate = @End.entities.add_group

#PLATE
@Plate_Circle = @Plate.entities.add_circle([0,0, (@Half_Susp_Length-@Plate_Offset)], [0, 0, 1] , @Plates_Radius, @Detail)
@Plate_Face = @Plate.entities.add_face(@Plate_Circle)
if @Plate_Face.normal.z == 1
@Plate_Face.reverse!
end

#Apply face color
@Plate_Face.material = @End_Color
@Plate_Face.back_material = @End_Color

@Plate_Face.pushpull(@Plate_Thickness, true)

#Plate detail
@Plate_Circle2 = @Plate.entities.add_circle([0,0, (@Half_Susp_Length-@Plate_Offset) ], [0, 0, 1] , @Plates_Radius-(@Plate_Thickness/2), @Detail)

Sketchup.active_model.selection.clear
Sketchup.active_model.selection.add(@Plate_Circle)

transform = Geom::Transformation.new([ 0, 0, -(@Plate_Thickness/4)*3 ])
@Plate.entities.transform_entities(transform, @Plate_Circle)
# --------------------------------------------------------------------------

#ANCHOR
@Anchor = @End.entities.add_group
@Anc_Bev = (@Anchor_Thickness/4)
@Anc_Depth = @Cilinder_Diameter

@Anchor_Arc = @Anchor.entities.add_arc [0, 0, @Half_Susp_Length], [-1,0,0], [0,1,0], @Hole_Diameter/2+@Anchor_Thickness, 0.degrees, 180.degrees, @Detail/2

@Total_Elongation = @Hole_Diameter/2 + @Anchor_Thickness + @End_Elongation

@Elongation_Line1 = @Anchor.entities.add_line [(@Hole_Diameter/2+@Anchor_Thickness), 0, @Half_Susp_Length], [@Hole_Diameter/2+@Anchor_Thickness, 0, @Half_Susp_Length-@Total_Elongation]
@Elongation_Line2 = @Anchor.entities.add_line [-(@Hole_Diameter/2+@Anchor_Thickness), 0, @Half_Susp_Length], [-(@Hole_Diameter/2+@Anchor_Thickness), 0, @Half_Susp_Length-@Total_Elongation]

model = Sketchup.active_model
entities = model.active_entities
Sketchup.active_model.selection.clear
@Anchor_Bevel_Path1 = @Anchor_Arc[0].all_connected

@Elongation_Line3 = @Anchor.entities.add_line [-(@Hole_Diameter/2+@Anchor_Thickness), 0, @Half_Susp_Length-@Total_Elongation], [(@Hole_Diameter/2+@Anchor_Thickness), 0, @Half_Susp_Length-@Total_Elongation]

@End_Hole1 = @Anchor.entities.add_circle([0,0,@Half_Susp_Length], [0, 1, 0] , @Hole_Diameter/2, @Detail)

#Anchor Face
@Anchor_Face1 = @Anchor.entities.add_face(@End_Hole1)
@Anchor_Path = @Elongation_Line3.all_connected
@Anchor_Face2 = @Anchor.entities.add_face(@Anchor_Path)
@Anchor_Face1.erase!

if @Anchor_Face2.normal.y == -1
@Anchor_Face2.reverse!
end

#Apply face color
@Anchor_Face2.material = @End_Color
@Anchor_Face2.back_material = @End_Color

status = @Anchor_Face2.pushpull(@Anc_Depth, true)

#Bevel edges 1st side
@End_Hole2 = @Anchor.entities.add_circle([0,0,@Half_Susp_Length], [0, 1, 0] , @Hole_Diameter/2+@Anc_Bev, @Detail)
@Anchor_Arc2 = @Anchor.entities.add_arc [0, 0, @Half_Susp_Length], [-1,0,0], [0,1,0], @Hole_Diameter/2+@Anchor_Thickness-@Anc_Bev, 0.degrees, 180.degrees, @Detail/2
@Elongation_Line12 = @Anchor.entities.add_line [(@Hole_Diameter/2+@Anchor_Thickness)-@Anc_Bev, 0, @Half_Susp_Length], [@Hole_Diameter/2+@Anchor_Thickness-@Anc_Bev, 0, @Half_Susp_Length-@Total_Elongation]
@Elongation_Line22 = @Anchor.entities.add_line [-(@Hole_Diameter/2+@Anchor_Thickness-@Anc_Bev), 0, @Half_Susp_Length], [-(@Hole_Diameter/2+@Anchor_Thickness-@Anc_Bev), 0, @Half_Susp_Length-@Total_Elongation]

Sketchup.active_model.selection.clear
Sketchup.active_model.selection.add(@Anchor_Bevel_Path1)
transform = Geom::Transformation.new([ 0, @Anc_Bev, 0 ])
@Anchor.entities.transform_entities(transform, @Anchor_Bevel_Path1)
@Anchor.entities.transform_entities(transform, @End_Hole1)


#Bevel edges 2nd side
@End_Hole1_2 = @Anchor.entities.add_circle([0, @Anc_Depth, @Half_Susp_Length], [0, 1, 0] , @Hole_Diameter/2+@Anc_Bev, @Detail)
@Anchor_Arc1_2 = @Anchor.entities.add_arc [0, @Anc_Depth, @Half_Susp_Length], [-1,0,0], [0,1,0], @Hole_Diameter/2+@Anchor_Thickness-@Anc_Bev, 0.degrees, 180.degrees, @Detail/2
@Elongation_Line12_2 = @Anchor.entities.add_line [(@Hole_Diameter/2+@Anchor_Thickness)-@Anc_Bev, @Anc_Depth, @Half_Susp_Length], [@Hole_Diameter/2+@Anchor_Thickness-@Anc_Bev, @Anc_Depth, @Half_Susp_Length-@Total_Elongation]
@Elongation_Line22_2 = @Anchor.entities.add_line [-(@Hole_Diameter/2+@Anchor_Thickness-@Anc_Bev), @Anc_Depth, @Half_Susp_Length], [-(@Hole_Diameter/2+@Anchor_Thickness-@Anc_Bev), @Anc_Depth, @Half_Susp_Length-@Total_Elongation]

#External edges 2nd side
@End_Hole2_2 = @Anchor.entities.add_circle([0, @Anc_Depth, @Half_Susp_Length], [0, 1, 0] , @Hole_Diameter/2, @Detail)
@Anchor_Arc_2 = @Anchor.entities.add_arc [0, @Anc_Depth, @Half_Susp_Length], [-1,0,0], [0,1,0], @Hole_Diameter/2+@Anchor_Thickness, 0.degrees, 180.degrees, @Detail/2
@Elongation_Line1_2 = @Anchor.entities.add_line [(@Hole_Diameter/2+@Anchor_Thickness), @Anc_Depth, @Half_Susp_Length], [@Hole_Diameter/2+@Anchor_Thickness, @Anc_Depth, @Half_Susp_Length-@Total_Elongation]
@Elongation_Line2_2 = @Anchor.entities.add_line [-(@Hole_Diameter/2+@Anchor_Thickness), @Anc_Depth, @Half_Susp_Length], [-(@Hole_Diameter/2+@Anchor_Thickness), @Anc_Depth, @Half_Susp_Length-@Total_Elongation]


Sketchup.active_model.selection.clear
Sketchup.active_model.selection.add(@End_Hole2_2)
Sketchup.active_model.selection.add(@Anchor_Arc_2)
Sketchup.active_model.selection.add(@Elongation_Line1_2)
Sketchup.active_model.selection.add(@Elongation_Line2_2)

transform = Geom::Transformation.new([ 0, -@Anc_Bev, 0 ])
@Anchor.entities.transform_entities(transform, @Elongation_Line1_2)
@Anchor.entities.transform_entities(transform, @Elongation_Line2_2)
@Anchor.entities.transform_entities(transform, @End_Hole2_2)

@Anchor = @Anchor.move! [0, -@Anc_Depth/2, 0]
@End = @End.to_component

#2nd END
@End2 = @End.copy
transformation = Geom::Transformation.rotation([0,0,0], [0,1,0], 180.degrees)
@End2.transform!(transformation)
)

print 'Make Adjustable Suspension - Debug point 6/7 ok'

(# COMPRESSOR--------------------------------------------------------------------
#COMPRESSOR
@Compressor = @Structure.entities.add_group
@Comp_Bevel = @Compressor_Thickness/4

@Compressor_Circle1 = @Compressor.entities.add_circle([ 0, 0, (-@Half_Range+@Casing_Length-@Compression_Range)], [0, 0, 1] , @Casing_Out_Radius, @Detail)
@Compressor_Circle2  = @Compressor.entities.add_circle([ 0, 0, (-@Half_Range+@Casing_Length-@Compression_Range)], [0, 0, 1] , @Plates_Radius, @Detail)

@Compressor_Face1 = @Compressor.entities.add_face(@Compressor_Circle1)
@Compressor_Face2 = @Compressor.entities.add_face(@Compressor_Circle2)
@Compressor_Face1.erase!

if @Compressor_Face2.normal.z == -1
@Compressor_Face2.reverse!
end

#Apply face color
@Compressor_Face2.material = @Compressor_Color
@Compressor_Face2.back_material = @Compressor_Color

@Compressor_Face2.pushpull(-@Compressor_Thickness, true)


@Compressor_Circle3  = @Compressor.entities.add_circle([ 0, 0, (-@Half_Range+@Casing_Length-@Compression_Range)], [0, 0, 1] , @Plates_Radius-@Comp_Bevel, @Detail)
@Compressor_Circle4  = @Compressor.entities.add_circle([ 0, 0, (-@Half_Range+@Casing_Length-@Compression_Range-@Compressor_Thickness)], [0, 0, 1] , @Plates_Radius-@Comp_Bevel, @Detail)
@Compressor_Circle5  = @Compressor.entities.add_circle([ 0, 0, (-@Half_Range+@Casing_Length-@Compression_Range-@Compressor_Thickness)], [0, 0, 1] , @Plates_Radius, @Detail)


Sketchup.active_model.selection.clear
Sketchup.active_model.selection.add(@Compressor_Circle5)

transform = Geom::Transformation.new([ 0, 0, -@Comp_Bevel ])
@Compressor.entities.transform_entities(transform, @Compressor_Circle1)
@Compressor.entities.transform_entities(transform, @Compressor_Circle2)

transform = Geom::Transformation.new([ 0, 0, @Comp_Bevel ])
@Compressor.entities.transform_entities(transform, @Compressor_Circle5)
)

if @MakeRef == "No"
@Reference.erase!
end


print 'Make Adjustable Suspension - Debug point 7/7 ok'
#Reset Scale
scale_transform = Geom::Transformation.scaling([0,0,0], 1/@Scale)
@Suspension.transformation *= scale_transform
Sketchup.active_model.selection.clear
#--------------------------------------------------------------------------

 #Timer end
@end_time = Time.now
@Total_Time = @end_time - @start_time
print "Success. (" + @Total_Time.to_s + " seconds) \n \n"
Taxsola.soundeffect(1) #0: Installation | 1: Success | 2: Notification
#--------------------------------------------------------------------------
end

	end
end
#-------------------------------------------------------------------------------