=begin
#-------------------------------
Author: Tax, 2021
Description:
#-------------------------------
=end


#-------------------------------------------------------------------------------
module Taxsola
	module Tax_Engineering

def self.bicycle_wheel_dialog
#Colors
@Hub_Color = [35,35,35]
@Spokes_Color = [60,60,60]
@Rim_Color = [85,85,85]
@Tyre_Color = [10,10,10]
@Scale = 1000.00
@Hub_Holes_Factor = 0.5 #Radial distance on hub plate

#DEFAULT VALUES
@Choosen_Preset = "Custom"
@Detail = 36
@Rim_Inner_Diameter = 647.00.mm
@Hub_Hole_Diameter = 20.00.mm
@N_Spokes = 20
@Spoke_Diameter = 2.50.mm
@Hub_Width = 100.00.mm
@Rim_Width = 24.00.mm
@Hub_Thickness = 5.00.mm
@Rim_Thickness = 2.00.mm
@Tyre_Thickness = 5.00.mm
@Rim_Height = 26.00.mm
@Tyre_Height = 50.00.mm
@Hub_Plate_Offset = 70.00
@Spoke_Hub_Plate_Ratio = 6
@Rim_Plate_Offset = 50.00
@MakeRef = "Yes"

(#PRESETS SETUP
@Presets = {
"Custom": [],
"Climber (12'' x 23c)": [208.8.mm,17.0.mm,25.0.mm,23.0.mm],
"Climber (12'' x 32c)": [190.8.mm,17.0.mm,25.0.mm,32.0.mm],
"Climber (12'' x 48c)": [158.8.mm,17.0.mm,25.0.mm,48.0.mm],
"Climber (14'' x 23c)": [259.6.mm,17.0.mm,25.0.mm,23.0.mm],
"Climber (14'' x 32c)": [241.6.mm,17.0.mm,25.0.mm,32.0.mm],
"Climber (14'' x 48c)": [209.6.mm,17.0.mm,25.0.mm,48.0.mm],
"Climber (16'' x 23c)": [310.4.mm,17.0.mm,25.0.mm,23.0.mm],
"Climber (16'' x 32c)": [292.4.mm,17.0.mm,25.0.mm,32.0.mm],
"Climber (16'' x 48c)": [260.4.mm,17.0.mm,25.0.mm,48.0.mm],
"Climber (20'' x 23c)": [412.mm,17.0.mm,25.0.mm,23.0.mm],
"Climber (20'' x 32c)": [394.mm,17.0.mm,25.0.mm,32.0.mm],
"Climber (20'' x 48c)": [362.mm,17.0.mm,25.0.mm,48.0.mm],
"Climber (24'' x 23c)": [513.6.mm,17.0.mm,25.0.mm,23.0.mm],
"Climber (24'' x 32c)": [495.6.mm,17.0.mm,25.0.mm,32.0.mm],
"Climber (24'' x 48c)": [463.6.mm,17.0.mm,25.0.mm,48.0.mm],
"Climber (26'' x 23c)": [564.4.mm,17.0.mm,25.0.mm,23.0.mm],
"Climber (26'' x 32c)": [546.4.mm,17.0.mm,25.0.mm,32.0.mm],
"Climber (26'' x 48c)": [514.4.mm,17.0.mm,25.0.mm,48.0.mm],
"Climber (27.5'' x 23c)": [602.5.mm,17.0.mm,25.0.mm,23.0.mm],
"Climber (27.5'' x 32c)": [584.5.mm,17.0.mm,25.0.mm,32.0.mm],
"Climber (27.5'' x 48c)": [552.5.mm,17.0.mm,25.0.mm,48.0.mm],
"Climber (29'' x 23c)": [640.6.mm,17.0.mm,25.0.mm,23.0.mm],
"Climber (29'' x 32c)": [622.6.mm,17.0.mm,25.0.mm,32.0.mm],
"Climber (29'' x 48c)": [590.6.mm,17.0.mm,25.0.mm,48.0.mm],
"Racer (12'' x 23c)": [188.8.mm,17.0.mm,35.0.mm,23.0.mm],
"Racer (12'' x 32c)": [170.8.mm,17.0.mm,35.0.mm,32.0.mm],
"Racer (12'' x 48c)": [138.8.mm,17.0.mm,35.0.mm,48.0.mm],
"Racer (14'' x 23c)": [239.6.mm,17.0.mm,35.0.mm,23.0.mm],
"Racer (14'' x 32c)": [221.6.mm,17.0.mm,35.0.mm,32.0.mm],
"Racer (14'' x 48c)": [189.6.mm,17.0.mm,35.0.mm,48.0.mm],
"Racer (16'' x 23c)": [290.4.mm,17.0.mm,35.0.mm,23.0.mm],
"Racer (16'' x 32c)": [272.4.mm,17.0.mm,35.0.mm,32.0.mm],
"Racer (16'' x 48c)": [240.4.mm,17.0.mm,35.0.mm,48.0.mm],
"Racer (20'' x 23c)": [392.mm,17.0.mm,35.0.mm,23.0.mm],
"Racer (20'' x 32c)": [374.mm,17.0.mm,35.0.mm,32.0.mm],
"Racer (20'' x 48c)": [342.mm,17.0.mm,35.0.mm,48.0.mm],
"Racer (24'' x 23c)": [493.6.mm,17.0.mm,35.0.mm,23.0.mm],
"Racer (24'' x 32c)": [475.6.mm,17.0.mm,35.0.mm,32.0.mm],
"Racer (24'' x 48c)": [443.6.mm,17.0.mm,35.0.mm,48.0.mm],
"Racer (26'' x 23c)": [544.4.mm,17.0.mm,35.0.mm,23.0.mm],
"Racer (26'' x 32c)": [526.4.mm,17.0.mm,35.0.mm,32.0.mm],
"Racer (26'' x 48c)": [494.4.mm,17.0.mm,35.0.mm,48.0.mm],
"Racer (27.5'' x 23c)": [582.5.mm,17.0.mm,35.0.mm,23.0.mm],
"Racer (27.5'' x 32c)": [564.5.mm,17.0.mm,35.0.mm,32.0.mm],
"Racer (27.5'' x 48c)": [532.5.mm,17.0.mm,35.0.mm,48.0.mm],
"Racer (29'' x 23c)": [620.6.mm,17.0.mm,35.0.mm,23.0.mm],
"Racer (29'' x 32c)": [602.6.mm,17.0.mm,35.0.mm,32.0.mm],
"Racer (29'' x 48c)": [570.6.mm,17.0.mm,35.0.mm,48.0.mm],
"All-round (12'' x 23c)": [158.8.mm,17.0.mm,50.0.mm,23.0.mm],
"All-round (12'' x 32c)": [140.8.mm,17.0.mm,50.0.mm,32.0.mm],
"All-round (12'' x 48c)": [108.8.mm,17.0.mm,50.0.mm,48.0.mm],
"All-round (14'' x 23c)": [209.6.mm,17.0.mm,50.0.mm,23.0.mm],
"All-round (14'' x 32c)": [191.6.mm,17.0.mm,50.0.mm,32.0.mm],
"All-round (14'' x 48c)": [159.6.mm,17.0.mm,50.0.mm,48.0.mm],
"All-round (16'' x 23c)": [260.4.mm,17.0.mm,50.0.mm,23.0.mm],
"All-round (16'' x 32c)": [242.4.mm,17.0.mm,50.0.mm,32.0.mm],
"All-round (16'' x 48c)": [210.4.mm,17.0.mm,50.0.mm,48.0.mm],
"All-round (20'' x 23c)": [362.mm,17.0.mm,50.0.mm,23.0.mm],
"All-round (20'' x 32c)": [344.mm,17.0.mm,50.0.mm,32.0.mm],
"All-round (20'' x 48c)": [312.mm,17.0.mm,50.0.mm,48.0.mm],
"All-round (24'' x 23c)": [463.6.mm,17.0.mm,50.0.mm,23.0.mm],
"All-round (24'' x 32c)": [445.6.mm,17.0.mm,50.0.mm,32.0.mm],
"All-round (24'' x 48c)": [413.6.mm,17.0.mm,50.0.mm,48.0.mm],
"All-round (26'' x 23c)": [514.4.mm,17.0.mm,50.0.mm,23.0.mm],
"All-round (26'' x 32c)": [496.4.mm,17.0.mm,50.0.mm,32.0.mm],
"All-round (26'' x 48c)": [464.4.mm,17.0.mm,50.0.mm,48.0.mm],
"All-round (27.5'' x 23c)": [552.5.mm,17.0.mm,50.0.mm,23.0.mm],
"All-round (27.5'' x 32c)": [534.5.mm,17.0.mm,50.0.mm,32.0.mm],
"All-round (27.5'' x 48c)": [502.5.mm,17.0.mm,50.0.mm,48.0.mm],
"All-round (29'' x 23c)": [590.6.mm,17.0.mm,50.0.mm,23.0.mm],
"All-round (29'' x 32c)": [572.6.mm,17.0.mm,50.0.mm,32.0.mm],
"All-round (29'' x 48c)": [540.6.mm,17.0.mm,50.0.mm,48.0.mm],
"Flat terrain (12'' x 23c)": [128.8.mm,17.0.mm,65.0.mm,23.0.mm],
"Flat terrain (12'' x 32c)": [110.8.mm,17.0.mm,65.0.mm,32.0.mm],
"Flat terrain (12'' x 48c)": [78.8.mm,17.0.mm,65.0.mm,48.0.mm],
"Flat terrain (14'' x 23c)": [179.6.mm,17.0.mm,65.0.mm,23.0.mm],
"Flat terrain (14'' x 32c)": [161.6.mm,17.0.mm,65.0.mm,32.0.mm],
"Flat terrain (14'' x 48c)": [129.6.mm,17.0.mm,65.0.mm,48.0.mm],
"Flat terrain (16'' x 23c)": [230.4.mm,17.0.mm,65.0.mm,23.0.mm],
"Flat terrain (16'' x 32c)": [212.4.mm,17.0.mm,65.0.mm,32.0.mm],
"Flat terrain (16'' x 48c)": [180.4.mm,17.0.mm,65.0.mm,48.0.mm],
"Flat terrain (20'' x 23c)": [332.mm,17.0.mm,65.0.mm,23.0.mm],
"Flat terrain (20'' x 32c)": [314.mm,17.0.mm,65.0.mm,32.0.mm],
"Flat terrain (20'' x 48c)": [282.mm,17.0.mm,65.0.mm,48.0.mm],
"Flat terrain (24'' x 23c)": [433.6.mm,17.0.mm,65.0.mm,23.0.mm],
"Flat terrain (24'' x 32c)": [415.6.mm,17.0.mm,65.0.mm,32.0.mm],
"Flat terrain (24'' x 48c)": [383.6.mm,17.0.mm,65.0.mm,48.0.mm],
"Flat terrain (26'' x 23c)": [484.4.mm,17.0.mm,65.0.mm,23.0.mm],
"Flat terrain (26'' x 32c)": [466.4.mm,17.0.mm,65.0.mm,32.0.mm],
"Flat terrain (26'' x 48c)": [434.4.mm,17.0.mm,65.0.mm,48.0.mm],
"Flat terrain (27.5'' x 23c)": [522.5.mm,17.0.mm,65.0.mm,23.0.mm],
"Flat terrain (27.5'' x 32c)": [504.5.mm,17.0.mm,65.0.mm,32.0.mm],
"Flat terrain (27.5'' x 48c)": [472.5.mm,17.0.mm,65.0.mm,48.0.mm],
"Flat terrain (29'' x 23c)": [560.6.mm,17.0.mm,65.0.mm,23.0.mm],
"Flat terrain (29'' x 32c)": [542.6.mm,17.0.mm,65.0.mm,32.0.mm],
"Flat terrain (29'' x 48c)": [510.6.mm,17.0.mm,65.0.mm,48.0.mm]
}
@Presets_String = ""
@Presets.each {|key,value| @Presets_String += key.to_s; @Presets_String += '|'}
@Presets_String.chomp!'|'
)


@Verification = "NOT OK"
until @Verification == "OK"
#-------------------------------------------------------------------------------
@Verification = "OK"

prompts		=	["Preset: ", "General detail: ", "Rim diameter: ", "Hub hole diameter: ", "Spokes: ", "Spoke diameter: ", "Hub width: ", "Rim width: ", "Hub thickness: ", "Rim thickness: ", "Tyre thickness: ", "Rim height: ", "Tyre height: ", "Hub plate offset (0-100%): ", "Spoke - Hub plate ratio: ", "Rim plate offset (0-100%): ", "Make references: "]
defaults	=	[@Choosen_Preset, @Detail, @Rim_Inner_Diameter, @Hub_Hole_Diameter, @N_Spokes, @Spoke_Diameter, @Hub_Width, @Rim_Width, @Hub_Thickness, @Rim_Thickness, @Tyre_Thickness, @Rim_Height, @Tyre_Height, @Hub_Plate_Offset, @Spoke_Hub_Plate_Ratio, @Rim_Plate_Offset, @MakeRef]
list		=	[@Presets_String, "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "Yes|No"]

val = UI.inputbox(prompts, defaults, list, "Make Bicycle Wheel")
if val
	@Choosen_Preset, @Detail, @Rim_Inner_Diameter, @Hub_Hole_Diameter, @N_Spokes, @Spoke_Diameter, @Hub_Width, @Rim_Width, @Hub_Thickness, @Rim_Thickness, @Tyre_Thickness, @Rim_Height, @Tyre_Height, @Hub_Plate_Offset, @Spoke_Hub_Plate_Ratio, @Rim_Plate_Offset, @MakeRef = val;
else
	raise Exception.new("Make Bicycle Wheel error: BWxV.000 - Operation canceled.\n")
end
#-------------------------------------------------------------------------------

#LOAD PRESET
if (@Choosen_Preset != "Custom") #Get selected preset values into the variables
	puts ("Loading preset")
	@Preset_Values = @Presets[@Choosen_Preset.to_sym]
	@Rim_Inner_Diameter, @Rim_Width, @Rim_Height, @Tyre_Height = @Preset_Values
end


#INPUT LOG ---------------------------------------------------------------------
puts 'Make Bicycle Wheel operation:'

@Input_Values = [@Choosen_Preset, @Detail, @Rim_Inner_Diameter, @Hub_Hole_Diameter, @N_Spokes, @Spoke_Diameter, @Hub_Width, @Rim_Width, @Hub_Thickness, @Rim_Thickness, @Tyre_Thickness, @Rim_Height, @Tyre_Height, @Hub_Plate_Offset, @Spoke_Hub_Plate_Ratio, @Rim_Plate_Offset, @MakeRef]

@Log = ""
@Input_Values.each {|input| @Log += input.to_s + '|'}
@Log.chomp!'|'

puts 'Input log: '
puts @Log
#-------------------------------------------------------------------------------


(#VARIABLES

@Bevel = @Hub_Thickness/2.0
@Bevel2 = @Hub_Thickness/4.0

@N_Spokes = (@N_Spokes.to_i).abs
if @N_Spokes%2 != 0 then @N_Spokes += 1; end
@Spoke_Angular_Offset = ( 360.000.degrees / (2.00 * @N_Spokes) )

@Hub_Plate_Height = @Spoke_Diameter * @Spoke_Hub_Plate_Ratio

@Spoke_Holes_Radius = @Hub_Hole_Diameter/2.0 + @Hub_Thickness + (@Hub_Plate_Height - @Bevel) *@Hub_Holes_Factor
#-------------------------------------------------------------------------------
)


print 'Make Bicycle Wheel - Debug point 1/7 ok'


(#VERIFICATIONS

#Detail < 6
if (@Detail < 8)
UI.messagebox("error: BWxV.001 - Min general detail is 8.")
warn("Make Parts error: BWxV.001")
@Verification = "NOT OK"
end

#Spokes > 1
if (@N_Spokes <= 1)
UI.messagebox("error: BWxV.002 - Min spokes is 2.")
warn("Make Parts error: BWxV.002")
@Verification = "NOT OK"
end

if (@Hub_Width < @Rim_Width)
UI.messagebox("error: BWxV.003 - Hub width must be larger than rim width.")
warn("Make Parts error: BWxV.003")
@Verification = "NOT OK"
end

if ( (@Tyre_Thickness *1.2) >= (@Rim_Width - 2*@Rim_Thickness)/2.0 )
UI.messagebox("error: BWxV.004 - Tyre or Rim thickness are too large; or rim width is too small.")
warn("Make Parts error: BWxV.004")
@Verification = "NOT OK"
end

if (@Rim_Height <= (@Rim_Width/2.0) )
UI.messagebox("error: BWxV.005 - Rim height is too low.")
warn("Make Parts error: BWxV.005")
@Verification = "NOT OK"
end

if (@Tyre_Height <= 0)
UI.messagebox("error: BWxV.006 - Tyre height must be higher than 0.")
warn("Make Parts error: BWxV.006")
@Verification = "NOT OK"
end

if (@Hub_Hole_Diameter <= 0)
UI.messagebox("error: BWxV.007 - Hub hole diameter must be higher than 0.")
warn("Make Parts error: BWxV.007")
@Verification = "NOT OK"
end

if (@Rim_Inner_Diameter <= (@Hub_Hole_Diameter + @Hub_Thickness*2 + @Hub_Plate_Height*2)*1.5 )
UI.messagebox("error: BWxV.008 - Rim diameter is too small.")
warn("Make Parts error: BWxV.008")
@Verification = "NOT OK"
end

if (@Hub_Plate_Offset < 0) or (@Hub_Plate_Offset > 100)
UI.messagebox("error: BWxV.009 - Hub plate offset is out of range (0-100%).")
warn("Make Parts error: BWxV.009")
@Verification = "NOT OK"
end

if (@Rim_Plate_Offset < 0) or (@Rim_Plate_Offset > 100)
UI.messagebox("error: BWxV.010 - Rim plate offset is out of range (0-100%).")
warn("Make Parts error: BWxV.010")
@Verification = "NOT OK"
end


if ( ((@N_Spokes/2.0) * (2*@Bevel2 + @Spoke_Diameter) * 1.2) >= (2 * Math::PI * @Spoke_Holes_Radius) )
UI.messagebox("error: BWxV.011 - Too much spokes.")
warn("Make Parts error: BWxV.011")
@Verification = "NOT OK"
end

if ( @Spoke_Hub_Plate_Ratio < 2 )
UI.messagebox("error: BWxV.012 - Min Spoke-Hub_plate ratio is 2.")
warn("Make Parts error: BWxV.012")
@Verification = "NOT OK"
end

if ( (2*@Bevel2 + @Spoke_Diameter) * 1.2 >= (@Hub_Plate_Height - @Bevel) )
UI.messagebox("error: BWxV.013 - Spoke - Hub plate ratio is too low.")
warn("Make Parts error: BWxV.013")
@Verification = "NOT OK"
end

if ( @Spoke_Diameter <= 0 )
UI.messagebox("error: BWxV.014 - Spoke diameter must be higher than 0.")
warn("Make Parts error: BWxV.014")
@Verification = "NOT OK"
end

if ( @Hub_Thickness >= @Hub_Width/4.0 )
UI.messagebox("error: BWxV.015 - Hub thickness may be too high.")
warn("Make Parts error: BWxV.015")
@Verification = "NOT OK"
end
)

print("Verifications: " + @Verification.to_s + "\n")
#-------------------------------------------------------------------------------
end

# SET VARIABLES ON SCALE PT1 -------------------------------------------------------------------------------

@Tyre_Thickness = (@Tyre_Thickness * @Scale).to_l
@Tyre_Height = (@Tyre_Height * @Scale).to_l

@Hub_Hole_Diameter = (@Hub_Hole_Diameter * @Scale).to_l
@Hub_Width = (@Hub_Width * @Scale).to_l
@Hub_Thickness = (@Hub_Thickness * @Scale).to_l

@Spoke_Diameter = (@Spoke_Diameter * @Scale).to_l

@Rim_Inner_Diameter = (@Rim_Inner_Diameter * @Scale).to_l
@Rim_Height = (@Rim_Height * @Scale).to_l
@Rim_Width = (@Rim_Width * @Scale).to_l
@Rim_Thickness = (@Rim_Thickness * @Scale).to_l

# SET VARIABLES ON SCALE PT2 -------------------------------------------------------------------------------

@Bevel = @Hub_Thickness/2.0
@Bevel2 = @Hub_Thickness/4.0

@Hub_Plate_Height = @Spoke_Diameter * @Spoke_Hub_Plate_Ratio

@Spoke_Holes_Radius = @Hub_Hole_Diameter/2.0 + @Hub_Thickness + (@Hub_Plate_Height - @Bevel) *@Hub_Holes_Factor
#-------------------------------------------------------------------------------



#-------------------------------------------------------------------------------
print 'Make Bicycle Wheel - Debug point 2/7 ok'

@Continue = UI.messagebox("It can take a few minutes, please wait.", type = MB_OKCANCEL)
if (@Continue != IDOK) then raise Exception.new("Make Bicycle Wheel error: BWxV.000 - Operation canceled.\n"); end

#Timer start
@start_time = Time.now

#Define camera view ------------------------------------------------------------
camera = Sketchup::Camera.new([0, -200, 0], [0, 0, 0], Z_AXIS)
view = Sketchup.active_model.active_view
view.camera = camera

#Speed boost by disable UI updates
model = Sketchup.active_model
entities = model.active_entities
model.start_operation('Make Parts', true)
#-------------------------------------------------------------------------------


#Make Bicycle Wheel
model = Sketchup.active_model
entities = model.active_entities
@Wheel = Sketchup.active_model.entities.add_group
@Hub = @Wheel.entities.add_group
@Hub_Holes = @Wheel.entities.add_group

#SOME HUB PARAMETERS ----------------------------------------------------------------
@Plate_Min = (@Spoke_Diameter + @Hub_Thickness)
@Plate_Max = (@Hub_Width/2.0) - @Bevel
@Plate_Position = ( ((@Plate_Max - @Plate_Min)/100.00) * @Hub_Plate_Offset) + @Plate_Min
#------------------------------------------------------------------------------------

#Rim Plate Position ----------------------------------------------------------------
@Top_Rim = (@Rim_Inner_Diameter/2.0) + @Rim_Height
@Rim_Plate_Min = @Top_Rim
@Rim_Plate_Max = (@Rim_Inner_Diameter/2.0) + (@Rim_Width/2.0) + @Rim_Thickness 
@Rim_Plate_Position = ( ((@Rim_Plate_Max - @Rim_Plate_Min)/100.00) * @Rim_Plate_Offset) + @Rim_Plate_Min
#------------------------------------------------------------------------------------



(#MAKING HUB SILHOUETE
@Point1 = [0, ((@Hub_Width/2.0)-(@Bevel)), (@Hub_Hole_Diameter/2.0)]
@Point2 = [0, -((@Hub_Width/2.0)-(@Bevel)), (@Hub_Hole_Diameter/2.0)]
@Base_Line = @Hub.entities.add_line @Point1, @Point2

@Arc1 = @Hub.entities.add_arc [0, @Point1.y, @Point1.z+@Bevel], [0,0,-1], [1,0,0], @Bevel, 0.degrees, 180.degrees, (@Detail/4.0)+2
@Arc2 = @Hub.entities.add_arc [0, @Point2.y, @Point2.z+@Bevel], [0,0,1], [1,0,0], @Bevel, 0.degrees, 180.degrees, (@Detail/4.0)+2

@Point3 = [0,@Point1.y, @Point1.z + @Hub_Thickness]
@Point4 = [0,@Point2.y, @Point2.z + @Hub_Thickness]

@Line2 = @Hub.entities.add_line @Point3, [0, @Plate_Position, @Point3.z]
@Line3 = @Hub.entities.add_line @Point4, [0, -@Plate_Position, @Point4.z]

#HUB PLATE 1
@Hub_Plate1_1 = @Hub.entities.add_line [0, @Plate_Position, @Point3.z], [0, @Plate_Position, (@Point3.z + @Hub_Plate_Height - @Bevel)]

@Hub_Plate1_2 = @Hub.entities.add_line [0, (@Plate_Position-@Hub_Thickness), @Point3.z], [0, (@Plate_Position-@Hub_Thickness), (@Point3.z + @Hub_Plate_Height - @Bevel)]

@Hub_Plate1_Arc = @Hub.entities.add_arc [0, (@Plate_Position-(@Hub_Thickness/2.0)), (@Point3.z + @Hub_Plate_Height - @Bevel)], [0,1,0], [1,0,0], @Bevel, 0.degrees, 180.degrees, (@Detail/4.0)+2


#HUB PLATE 2
@Hub_Plate2_1 = @Hub.entities.add_line [0, -@Plate_Position, @Point4.z], [0, -@Plate_Position, (@Point4.z + @Hub_Plate_Height - @Bevel)]

@Hub_Plate2_2 = @Hub.entities.add_line [0, -(@Plate_Position-@Hub_Thickness), @Point4.z], [0, -(@Plate_Position-@Hub_Thickness), (@Point4.z + @Hub_Plate_Height - @Bevel)]

@Hub_Plate2_Arc = @Hub.entities.add_arc [0, -(@Plate_Position-(@Hub_Thickness/2.0)), (@Point4.z + @Hub_Plate_Height - @Bevel)], [0,1,0], [1,0,0], @Bevel, 0.degrees, 180.degrees, (@Detail/4.0)+2


@Link_Line = @Hub.entities.add_line [0, (@Plate_Position-@Hub_Thickness), @Point3.z], [0, -(@Plate_Position-@Hub_Thickness), @Point4.z]


#Make hub silhouete
Sketchup.active_model.selection.clear
@Silhouete_Path = @Base_Line.all_connected
@Silhouete_Face = @Hub.entities.add_face(@Silhouete_Path)
if @Silhouete_Face.normal.x == -1 then @Silhouete_Face.reverse!; end
)

#Make 3d hub

#MAKE FOLLOWME PATH 1
@Rim_Circle1 = @Hub.entities.add_circle([0,0,0], [0, 1, 0] , @Rim_Inner_Diameter/2.0, @Detail)
@Rim_Path1 = @Rim_Circle1.to_a

@Silhouete_Face.followme(@Rim_Path1)
@Rim_Path1.each { |edge| edge.erase! }

(#Make hub holes
@Spoke_Holes_Radius = @Hub_Hole_Diameter/2.0 + @Hub_Thickness + (@Hub_Plate_Height - @Bevel) *@Hub_Holes_Factor
@Spoke_Holes_Offset = 360.00.degrees / (@N_Spokes/2.0)

for step in 0..(@N_Spokes/2.0) -1
@x = Math.cos(step * @Spoke_Holes_Offset) * @Spoke_Holes_Radius
@y = -@Hub_Width/2.0
@z = Math.sin(step * @Spoke_Holes_Offset) * @Spoke_Holes_Radius

@Circle1 = @Hub_Holes.entities.add_circle([@x, @y, @z], [0, 1, 0] , (@Spoke_Diameter/2.0), @Detail)
@F1 = @Hub_Holes.entities.add_face(@Circle1)
@F1.pushpull(@Hub_Width, false)
end
@Hub = @Hub_Holes.subtract(@Hub)
)

print 'Make Bicycle Wheel - Debug point 3/7 ok'

(#Make hub holes BEVEL
Sketchup.active_model.selection.clear
transform1 = Geom::Transformation.new([0,-@Bevel2,0])
transform2 = Geom::Transformation.new([0,@Bevel2,0])
# HUB HOLES -------------------------------------------------------------------------
for step in 0..(@N_Spokes/2) -1
@x = Math.cos(step * @Spoke_Holes_Offset) * @Spoke_Holes_Radius
@y = @Plate_Position
@z = Math.sin(step * @Spoke_Holes_Offset) * @Spoke_Holes_Radius
# 1 ------------------------------------------------------------------------------------

@Circle1 = @Hub.entities.add_circle([@x, @y, @z], [0, 1, 0] , (@Spoke_Diameter/2.0), @Detail)
@Circle2 = @Hub.entities.add_circle([@x, @y, @z], [0, 1, 0] , (@Spoke_Diameter/2.0)+@Bevel2, @Detail)

Sketchup.active_model.selection.add(@Circle1)
@Hub.entities.transform_entities(transform1, @Circle1)
Sketchup.active_model.selection.clear

# 2 ------------------------------------------------------------------------------------

@Circle1 = @Hub.entities.add_circle([@x, @y - @Hub_Thickness, @z], [0, 1, 0] , (@Spoke_Diameter/2.0), @Detail)
@Circle2 = @Hub.entities.add_circle([@x, @y - @Hub_Thickness, @z], [0, 1, 0] , (@Spoke_Diameter/2.0)+@Bevel2, @Detail)

Sketchup.active_model.selection.clear
Sketchup.active_model.selection.add(@Circle1)
@Hub.entities.transform_entities(transform2, @Circle1)
Sketchup.active_model.selection.clear


@x = Math.cos(step * @Spoke_Holes_Offset) * @Spoke_Holes_Radius
@y = -@Plate_Position +@Hub_Thickness
@z = Math.sin(step * @Spoke_Holes_Offset) * @Spoke_Holes_Radius
# 3 ------------------------------------------------------------------------------------

@Circle1 = @Hub.entities.add_circle([@x, @y, @z], [0, 1, 0] , (@Spoke_Diameter/2.0), @Detail)
@Circle2 = @Hub.entities.add_circle([@x, @y, @z], [0, 1, 0] , (@Spoke_Diameter/2.0)+@Bevel2, @Detail)

Sketchup.active_model.selection.add(@Circle1)
@Hub.entities.transform_entities(transform1, @Circle1)
Sketchup.active_model.selection.clear

# 4 ------------------------------------------------------------------------------------

@Circle1 = @Hub.entities.add_circle([@x, @y - @Hub_Thickness, @z], [0, 1, 0] , (@Spoke_Diameter/2.0), @Detail)
@Circle2 = @Hub.entities.add_circle([@x, @y - @Hub_Thickness, @z], [0, 1, 0] , (@Spoke_Diameter/2.0)+@Bevel2, @Detail)

Sketchup.active_model.selection.clear
Sketchup.active_model.selection.add(@Circle1)
@Hub.entities.transform_entities(transform2, @Circle1)
Sketchup.active_model.selection.clear
end
#------------------------------------------------------------------------------------
)

@Hub.material = @Hub_Color

(#Make Rim Silhouete ---------------------------------------------------------------
@Rim = @Wheel.entities.add_group
@Rim_Holes = @Wheel.entities.add_group

#MAKE FOLLOWME PATH 2 - (for outer and inner parts of the rim)
@Rim_Circle2 = @Rim.entities.add_circle([0,0,0], [0, 1, 0] , @Rim_Inner_Diameter/4.0, @Detail)
@Rim_Path2 = @Rim_Circle2.to_a

@Rim_Center_Height = (@Rim_Inner_Diameter/2.0) + (@Rim_Width/2.0)


#Make outer path silhouete
@Rim_Base_Arc = @Rim.entities.add_arc [0, 0, @Rim_Center_Height], [0,1,0], [1,0,0], (@Rim_Width/2.0), 180.degrees, 360.degrees, (@Detail/2.0)

@L1 = @Rim.entities.add_line [0,(@Rim_Width/2.0),@Rim_Center_Height], [0,(@Rim_Width/2.0), @Top_Rim]
@L2 = @Rim.entities.add_line [0,-(@Rim_Width/2.0),@Rim_Center_Height], [0,-(@Rim_Width/2.0), @Top_Rim]

@Line_Plate_1 = @Rim.entities.add_line [0, ((@Rim_Width/2.0)-@Rim_Thickness), @Rim_Plate_Position], [0, -((@Rim_Width/2.0)-@Rim_Thickness), @Rim_Plate_Position]

@Line_H_1 = @Rim.entities.add_line [0, ((@Rim_Width/2.0)-@Rim_Thickness), @Top_Rim], [0, ((@Rim_Width/2.0)-@Rim_Thickness), @Rim_Plate_Position]
@Line_H_2 = @Rim.entities.add_line [0, -((@Rim_Width/2.0)-@Rim_Thickness), @Top_Rim], [0, -((@Rim_Width/2.0)-@Rim_Thickness), @Rim_Plate_Position]

@Line_Top_1 = @Rim.entities.add_line [0, ((@Rim_Width/2.0)), @Top_Rim], [0, ((@Rim_Width/2.0)-@Rim_Thickness), @Top_Rim]
@Line_Top_2 = @Rim.entities.add_line [0, -((@Rim_Width/2.0)), @Top_Rim], [0, -((@Rim_Width/2.0)-@Rim_Thickness), @Top_Rim]

#Make outer face
@Rim_Outer_Path = @Line_Plate_1.all_connected
@Rim_Outer_Face = @Rim.entities.add_face(@Rim_Outer_Path)

#Extrude outer
if @Rim_Outer_Face.normal.x == 1 then @Rim_Outer_Face.reverse!; end
@Rim_Solid = @Rim_Outer_Face.followme(@Rim_Path2)

#------------------------------------------------------------------------------------

#Make inner path silhouete
@Rim_Sup_Arc = @Rim.entities.add_arc [0, 0, @Rim_Center_Height], [0,1,0], [1,0,0], (@Rim_Width/2.0)-@Rim_Thickness, 180.degrees, 360.degrees, (@Detail/2.0)

@Line_Plate_2 = @Rim.entities.add_line [0, ((@Rim_Width/2.0)-@Rim_Thickness), (@Rim_Plate_Position-@Rim_Thickness)], [0, -((@Rim_Width/2.0)-@Rim_Thickness), (@Rim_Plate_Position-@Rim_Thickness)]

@Line_H_3 = @Rim.entities.add_line [0, ((@Rim_Width/2.0)-@Rim_Thickness), (@Rim_Plate_Position-@Rim_Thickness)], [0, ((@Rim_Width/2.0)-@Rim_Thickness), @Rim_Center_Height]
@Line_H_4 = @Rim.entities.add_line [0, -((@Rim_Width/2.0)-@Rim_Thickness), (@Rim_Plate_Position-@Rim_Thickness)], [0, -((@Rim_Width/2.0)-@Rim_Thickness), @Rim_Center_Height]

#Make inner face
@Rim_Inner_Path = @Line_Plate_2.all_connected
@Rim_Inner_Face = @Rim.entities.add_face(@Rim_Inner_Path)

#Extrude inner
if @Rim_Inner_Face.normal.x == -1 then @Rim_Inner_Face.reverse!; end
@Rim_Inner_Hole = @Rim_Inner_Face.followme(@Rim_Path2)


#Delete rim extrusion path
@Rim_Path2.each { |edge| edge.erase! }
)
#------------------------------------------------------------------------------------

print 'Make Bicycle Wheel - Debug point 4/7 ok'

(#Make Rim holes
@Rim_Holes_Offset = 360.00.degrees / @N_Spokes

for step in 0..(@N_Spokes-1)
@y = 0
@x = Math.cos(step * @Rim_Holes_Offset + @Spoke_Angular_Offset) * ((@Rim_Inner_Diameter/2.0)-(@Rim_Thickness*8))
@z = Math.sin(step * @Rim_Holes_Offset + @Spoke_Angular_Offset) * ((@Rim_Inner_Diameter/2.0)-(@Rim_Thickness*8))

@Circle2 = @Rim_Holes.entities.add_circle([@x, @y, @z], [@x, @y, @z] , (@Spoke_Diameter/2.0), @Detail)
@F2 = @Rim_Holes.entities.add_face(@Circle2)
@F2.pushpull(@Rim_Thickness*12, false)
end

@Rim = @Rim_Holes.subtract(@Rim)
)
@Rim.material = @Rim_Color


print 'Make Bicycle Wheel - Debug point 5/7 ok'

(#Make Tyre Silhouete
@Tyre = @Wheel.entities.add_group

@Top_Point = [0, 0, (@Rim_Inner_Diameter/2.0) + @Rim_Height + @Tyre_Height]
@Point_A = [0, ((@Rim_Width/2.0) - @Rim_Thickness), (@Rim_Inner_Diameter/2.0) + @Rim_Height]
@Point_B = [0, -((@Rim_Width/2.0) - @Rim_Thickness), (@Rim_Inner_Diameter/2.0) + @Rim_Height]

@Vector_1 = @Top_Point.vector_to( @Point_A )
@Vector_2 = @Top_Point.vector_to( @Point_B )

#Angle between 2 vectors ------------------------------------------------------------
@Angle1 = (@Vector_1.angle_between @Vector_2)
@Half_Angle = @Angle1/2.00

@CA = @Vector_1.length/2.00

@Hypotenuze = @CA / Math.cos(@Half_Angle)

@Center_Point = [0, 0, (@Rim_Inner_Diameter/2.0) + @Rim_Height + @Tyre_Height - @Hypotenuze]
#------------------------------------------------------------------------------------


@Vector_3 = @Center_Point.vector_to( @Point_A )
@Vector_4 = @Center_Point.vector_to( @Point_B )
@Angle2 = (@Vector_3.angle_between @Vector_4).radians

if (@Center_Point[2] >= @Point_A[2])
 @Tyre_Angle1 = 360.00 - @Angle2
else
 @Tyre_Angle1 = @Angle2
end

@Tyre_Outer_Arc = @Tyre.entities.add_arc @Center_Point, @Vector_3, [1,0,0], @Hypotenuze, 0, @Tyre_Angle1.degrees, @Detail
#------------------------------------------------------------------------------------

@Point_C = [0, ((@Rim_Width/2.0)-@Rim_Thickness-@Tyre_Thickness), @Top_Rim]
@Point_D = [0, -((@Rim_Width/2.0)-@Rim_Thickness-@Tyre_Thickness), @Top_Rim]
@Vector_5 = @Center_Point.vector_to( @Point_C )
@Vector_6 = @Center_Point.vector_to( @Point_D )
@Angle3 = (@Vector_5.angle_between @Vector_6).radians

if (@Center_Point[2] >= @Point_A[2])
 @Tyre_Angle2 = 360.00 - @Angle3
else
 @Tyre_Angle2 = @Angle3
end

@In_Rad = @Vector_5.length

@Tyre_Inner_Arc = @Tyre.entities.add_arc @Center_Point, @Vector_5, [1,0,0], (@Hypotenuze-@Tyre_Thickness), 0, @Tyre_Angle2.degrees, @Detail
#------------------------------------------------------------------------------------


@Tyre_Base_Line_1 = @Tyre.entities.add_line [0, ((@Rim_Width/2.0)-@Rim_Thickness), @Rim_Plate_Position], [0, ((@Rim_Width/2.0)-@Rim_Thickness-@Tyre_Thickness), @Rim_Plate_Position]
@Tyre_Base_Line_2 = @Tyre.entities.add_line [0, -((@Rim_Width/2.0)-@Rim_Thickness), @Rim_Plate_Position], [0, -((@Rim_Width/2.0)-@Rim_Thickness-@Tyre_Thickness), @Rim_Plate_Position]

@Tyre_Line_1 = @Tyre.entities.add_line [0, ((@Rim_Width/2.0)-@Rim_Thickness), @Top_Rim], [0, ((@Rim_Width/2.0)-@Rim_Thickness), @Rim_Plate_Position]
@Tyre_Line_2 = @Tyre.entities.add_line [0, -((@Rim_Width/2.0)-@Rim_Thickness), @Top_Rim], [0, -((@Rim_Width/2.0)-@Rim_Thickness), @Rim_Plate_Position]


@Anglar_Reduction = (180.00 - @Tyre_Angle2) / 2.0

@y = @Center_Point.y + ( Math.cos(@Anglar_Reduction.degrees) * (@Hypotenuze-@Tyre_Thickness) )
@z = @Center_Point.z + ( Math.sin(@Anglar_Reduction.degrees) * (@Hypotenuze-@Tyre_Thickness) )
@Arc_Point_A = [ 0, @y, @z]
@Arc_Point_B = [ 0, -@y, @z]

@Tyre_Line_3 = @Tyre.entities.add_line [0, ((@Rim_Width/2.0)-@Rim_Thickness-@Tyre_Thickness), @Rim_Plate_Position], @Arc_Point_A
@Tyre_Line_4 = @Tyre.entities.add_line [0, -((@Rim_Width/2.0)-@Rim_Thickness-@Tyre_Thickness), @Rim_Plate_Position], @Arc_Point_B
#------------------------------------------------------------------------------------
)


#Make tyre 3d
@Tyre_Silhouete_Path = @Tyre_Line_1.all_connected
@Tyre_Silhouete_Face = @Tyre.entities.add_face(@Tyre_Silhouete_Path)

#MAKE FOLLOWME PATH 3
@Rim_Circle3 = @Tyre.entities.add_circle([0,0,0], [0, 1, 0] , @Rim_Inner_Diameter/2.0, @Detail)
@Rim_Path3 = @Rim_Circle3.to_a


if !(@Tyre_Silhouete_Face.nil?)
 if @Tyre_Silhouete_Face.normal.x == -1 then @Tyre_Silhouete_Face.reverse!; end
 @Tyre_Silhouete_Face.followme(@Rim_Path3)
 @Tyre.material = @Tyre_Color
end

@Rim_Path3.each { |edge| edge.erase! }
#------------------------------------------------------------------------------------

print 'Make Bicycle Wheel - Debug point 6/7 ok'

(#Make Spoke
@Spoke_Reference = @Wheel.entities.add_group
@Spokes = @Wheel.entities.add_group
@Spoke_Pair = @Spokes.entities.add_group
@Spoke = @Spoke_Pair.entities.add_group

#Link line
@Spoke_Curve_Int_Point = [@Spoke_Holes_Radius, (@Plate_Position-@Hub_Thickness),0]
@Spoke_Curve_Ext_Point = [@Spoke_Holes_Radius, (@Plate_Position),0]
@Spoke_Link_Line = @Spoke_Reference.entities.add_line @Spoke_Curve_Ext_Point, @Spoke_Curve_Int_Point

#Arcs
@Arc_Center_1 = [@Spoke_Holes_Radius+(@Spoke_Diameter/2.0), (@Plate_Position-@Hub_Thickness),0]
@Arc_Center_2 = [@Spoke_Holes_Radius+(@Spoke_Diameter/2.0), (@Plate_Position),0]

@Spoke_Arc_1 = @Spoke_Reference.entities.add_arc @Arc_Center_1, [1,0,0], [0,0,1], (@Spoke_Diameter/2.0), 180.degrees, 270.degrees, @Detail/4.0
@Spoke_Arc_2 = @Spoke_Reference.entities.add_arc @Arc_Center_2, [1,0,0], [0,0,1], (@Spoke_Diameter/2.0), 90.degrees, 180.degrees, @Detail/4.0

#End line 1
@Spoke_C1 = [@Spoke_Holes_Radius+(@Spoke_Diameter/2.0), (@Plate_Position+(@Spoke_Diameter/2.0)), 0]
@Spoke_End_Point1 = [@Spoke_C1[0] + (@Hub_Plate_Height/2.0), @Spoke_C1[1], 0]
@End_Line_1 = @Spoke_Reference.entities.add_line @Spoke_C1, @Spoke_End_Point1


#2nd end projection ------------------------------------------------------------------
@Spoke_C2 = [@Spoke_Holes_Radius+(@Spoke_Diameter/2.0), (@Plate_Position-@Hub_Thickness-(@Spoke_Diameter/2.0)), 0]

@Spoke_C2_proj = [@Spoke_Holes_Radius+(@Spoke_Diameter/2.0), 0, 0]

@x = Math.cos(@Spoke_Angular_Offset) * (@Rim_Inner_Diameter/2.0 + @Rim_Thickness)
@y = 0
@z = Math.sin(@Spoke_Angular_Offset) * (@Rim_Inner_Diameter/2.0 + @Rim_Thickness)
@End_Projection = [@x, @y, @z]

@Spoke_Vector1 = @Spoke_C2_proj.vector_to( @End_Projection )

@Spoke_End_Point2 = [@Spoke_C2[0] + @Spoke_C2_proj.distance(@End_Projection), 0, 0]
@Spoke_Vector2 = @Spoke_C2_proj.vector_to( @Spoke_End_Point2 )
@End_Line_2 = @Spoke_Reference.entities.add_line @Spoke_C2, @Spoke_End_Point2
#------------------------------------------------------------------------------------
)

#Make Spoke 3d
@Spoke_Path = @Spoke_Reference.entities[0].all_connected
@Spoke_Silhouete = @Spoke.entities.add_circle(@Spoke_End_Point1, @Spoke_End_Point1.vector_to(@Spoke_C1), (@Spoke_Diameter/2.0), @Detail)

@Spoke_Face = @Spoke.entities.add_face(@Spoke_Silhouete)

if @Spoke_Face.normal.x == -1 then @Spoke_Face.reverse!; end
@Spoke_Face.followme(@Spoke_Path)

(#Make spoke bevel
@Spoke_Bevel = @Spoke_Diameter/4.0

Sketchup.active_model.selection.clear

@Spoke_Bevel_Path1 = @Spoke.entities.add_circle(@Spoke_End_Point1, @Spoke_End_Point1.vector_to(@Spoke_C1), (@Spoke_Diameter/2.0), @Detail)
@Spoke_Bevel_Path2 = @Spoke.entities.add_circle(@Spoke_End_Point1, @Spoke_End_Point1.vector_to(@Spoke_C1), (@Spoke_Diameter/4.0), @Detail)

Sketchup.active_model.selection.add(@Spoke_Bevel_Path1)
transform = Geom::Transformation.new([-@Spoke_Bevel, 0, 0])
@Spoke.entities.transform_entities(transform, @Spoke_Bevel_Path1)

Sketchup.active_model.selection.clear
#------------------------------------------------------------------------------------
)

@Spoke.material = @Spokes_Color

#Angular Offset Rotation
@Spoke_Rot_Point = [@Spoke_Holes_Radius, (@Plate_Position-(@Hub_Thickness/2.0) ),0]
@Offset_Angle = @Spoke_Vector2.angle_between(@Spoke_Vector1)
@Spoke.entities.transform_entities(Geom::Transformation.rotation(@Spoke_Rot_Point, [0,-1,0], @Offset_Angle), @Spoke)
@Spoke = @Spoke.to_component

(#Copies
@Copy = @Spoke.copy
@Copy = entities.transform_entities(Geom::Transformation.rotation([0,0,0], [1,0,0], 180.degrees), @Copy)
@Spoke_Pair.material = @Spokes_Color

for step in 1..(@N_Spokes/2) -1
@Spokes_Angle = (step * @Spoke_Holes_Offset)
@Copy = @Spoke_Pair.copy
@Copy = entities.transform_entities(Geom::Transformation.rotation([0,0,0], [0,1,0], @Spokes_Angle), @Copy)
end
@Spokes.material = @Spokes_Color
)


@Spoke_Reference.erase!


#Make references
if (@MakeRef == "Yes")
@References = @Wheel.entities.add_group
@Origin_Point = @References.entities.add_cpoint [0, 0, 0]
@Axis_Line = @References.entities.add_line [0, @Hub_Width, 0], [0, -@Hub_Width, 0]
end

#Reset scale
scale_transform = Geom::Transformation.scaling([0,0,0], 1.0/@Scale)
@Wheel.transformation *= scale_transform

Sketchup.active_model.selection.clear
Sketchup.active_model.selection.add(@Wheel)

#------------------------------------------------------------------------------------
model.commit_operation
print 'Make Bicycle Wheel - Debug point 7/7 ok'
@end_time = Time.now
@Total_Time = @end_time - @start_time
print "Success. (" + @Total_Time.to_s + " seconds) \n \n"
Taxsola.soundeffect(1) #0: Installation | 1: Success | 2: Notification
#------------------------------------------------------------------------------------
end

	end
end
#-------------------------------------------------------------------------------