=begin
#-------------------------------
Author: Tax, 2021
#Description: 
#-------------------------------
=end


#-------------------------------------------------------------------------------
module Taxsola
require "bigdecimal/math"
require "bigdecimal/util"
include BigMath


	module Tax_Engineering

def self.FRS_dialog

print("\n\n")
print("--------------------")
print(Time.now)


(#BASIC INITIAL HANDLERS -----------------------------------------------------
model = Sketchup.active_model
entities = model.active_entities

@Selection = model.selection.to_a #All selection
	if (@Selection.length == 0)
		@msg = "Follow Rotate Scale"
		@msg += "\n\n"
		@msg += "Select:" + "\n"
		@msg += "1 profile group" + "\n"
		@msg += "A set of edges as path*" + "\n"
		@msg += "[*]default: straight up line."
		UI.messagebox(@msg)
		raise Exception.new(@msg)
	end

@Groups = @Selection.grep(Sketchup::Group).uniq #Groups on selection
	if (@Groups.length != 1)
		UI.messagebox("There must be 1 and only profile group on selection.")
		raise Exception.new("FRSxV.000 - Groups ammont != 1.")
	end

@Group = @Groups[0]
@Profile_Edges = @Group.entities.grep(Sketchup::Edge).uniq #Profile edges
	#HIGH PROFILE EDGES QUANTITY
	if (@Profile_Edges.length > 200)
		if (UI.messagebox("Theres " + @Profile_Edges.length.to_s + " profile edges selected.\nIt could freeze SU undefinitely!\n\nContinue?", type = MB_YESNO) != IDYES)
			raise Exception.new("FRSxV.001 - Aborted due to high profile edges quantity.")
		end
	end

	if (@Profile_Edges.length < 1)
		UI.messagebox("Operation canceled:\nThere are no edges inside profile group.")
		raise Exception.new("FRSxV.001 - No edges inside profile group.")
	end


@Path_Edges = @Selection.grep(Sketchup::Edge).uniq #Edges on selection

@MODE = ""
	if (@Path_Edges.length == 0)
		@MODE = "no path"
		print ("FRS mode: No path (edges) selected. Default mode operation." + "\n\n")
	else
		@MODE = "along path"
		print ("FRS mode: Follow path along operation." + "\n\n")
	end
#-----------------------------------------------------------------------------
)



#PATH SEGMENTS --------------------------------------------
@Path_Segments = []
if (@MODE == "along path")

@Path_Segments = Taxsola.generate_segments(@Path_Edges)

else #-----------------------------------------------------

#Default segments definiton
@pointA = Geom::Point3d.new(0,0,0)
@pointB = Geom::Point3d.new(0,0,10)
@Segment = [@pointA, @pointB]

@Path_Segments << @Segment

end


#PROFILE SEGMENTS ----------------------------------------
@Profile_Segments = []
@Profile_Segments = Taxsola.generate_segments(@Profile_Edges)



#SEGMENTS AMMOUNT REPORT
@Seg_Num1 = @Path_Segments.length
@Seg_Num2 = @Profile_Segments.length

print(@Seg_Num1.to_s + " path segments on selection.")
print(@Seg_Num2.to_s + " profile segments on selection." + "\n\n")
#-----------------------


#Flat profile segments on min variation axis
@Profile_Segments, @Flat_Axis = Taxsola.axial_flatten2(@Profile_Segments)

if (@Profile_Segments.length < @Seg_Num2)
	UI.messagebox("Profile segments reduced on flatting operation.\n\nFrom: "+ @Seg_Num2.to_s + "\nTo: " + @Profile_Segments.length.to_s, type = MB_OK)
end
#----------------------------------------------------------


#Default FRS inputs
@Section_Interval = 5.0.mm
@Up_Ref = "Roll on" # Roll on|Truncate|Z-corrected|Z-streched

@Rotation_Interp = "Linear Interval"
@Rotation_Parameter = 0.0.degrees
@Rot_Phase = 0.0.degrees
@Rot_Cycles = 1.0

@Rot_Exp_Log = 3.0 #Exponential/Logarithm mode

@Scale_Interp = "Linear Total"
@Scale_Parameter = 1.0 #Linear, Parabole and Sine wave modes
@Sca_Phase = 0.0.degrees
@Sca_Cycles = 1.0

@Sca_Exp_Log = 3.0 #Exponential/Logarithm mode

@Rev_Segs = "No"
@Invert_Tris = "No"

#For rotation
@Interpolations1 = "Linear Interval|Linear Total|Parabole|SineWave-Cycles|Exponential|Logarithm"
#For scale
@Interpolations2 = "Linear Total|Parabole|SineWave-Cycles|Exponential|Logarithm"
#------------------

@Verification = "NOT OK"
until @Verification == "OK"
#-------------------------------------------------------------------------------
@Verification = "OK"

#INPUT BOX
@Rotation_Parameter = @Rotation_Parameter.radians.round(3).to_s + "degrees"
@Rot_Phase = @Rot_Phase.radians.round(3).to_s + "degrees"
@Sca_Phase = @Sca_Phase.radians.round(3).to_s + "degrees"

@prompts = ["Section interval: ", "Up reference: ","Rotation interp: ", "Rotation param: ", "Rotation phase: ", "Rotation Cycles: ", "Rot Exp/Log: ", "Scale interp: ", "Scale param: ", "Scale phase: ", "Scale Cycles: ", "Scale Exp/Log: ", "Reverse segments? ", "Invert diagonals? "]
@defaults = [@Section_Interval, @Up_Ref, @Rotation_Interp, @Rotation_Parameter, @Rot_Phase, @Rot_Cycles, @Rot_Exp_Log, @Scale_Interp, @Scale_Parameter, @Sca_Phase, @Sca_Cycles, @Sca_Exp_Log, @Rev_Segs, @Invert_Tris]
@list = ["", "Roll on|Truncate|Z-corrected|Z-streched", @Interpolations1, "", "", "", "", @Interpolations2, "", "", "", "", "Yes|No", "Yes|No"]

@input = UI.inputbox(@prompts, @defaults, @list, "Follow Rotate Scale")
#---------

#GET INPUTS
if @input
	@Section_Interval, @Up_Ref, @Rotation_Interp, @Rotation_Parameter, @Rot_Phase, @Rot_Cycles, @Rot_Exp_Log, @Scale_Interp, @Scale_Parameter, @Sca_Phase, @Sca_Cycles, @Sca_Exp_Log, @Rev_Segs, @Invert_Tris = @input;
else
	raise Exception.new("FRS - Operation canceled. (Inputbox = false)")
end

#Personal method for improving UI experience with angles units
@Rotation_Parameter = Taxsola.to_angle(@Rotation_Parameter)
@Rot_Phase = Taxsola.to_angle(@Rot_Phase)
@Sca_Phase = Taxsola.to_angle(@Sca_Phase)


#INPUT LOG
@Input_Log = "Input log:\n"
@input.each {|field| @Input_Log += field.to_s + " | "}
print @Input_Log


#VERIFICATIONS
@V_Cod = "FRSxV."
@V_Num = 0

(
#1st verification
if (@Section_Interval <= 0)
@V_ID = "error: " + @V_Cod + @V_Num.to_s #error: FRSxV.xxx
@msg = @V_ID + " - Section interval must be higher than 0."
UI.messagebox(@msg); warn(@msg)
@Verification = "NOT OK"
end
@V_Num += 1

#2nd verification
if ((@Rotation_Parameter > 60.degrees) || (@Rotation_Parameter < -60.degrees)) && (@Rotation_Interp == "Linear Interval")
@V_ID = "error: " + @V_Cod + @V_Num.to_s #error: FRSxV.xxx
@msg = @V_ID + " - Rotation is out of range. (max +-60 for 'by interval' method)"
UI.messagebox(@msg); warn(@msg)
@Verification = "NOT OK"
end
@V_Num += 1

#3rd verification
if (@Rot_Cycles <= 0)
@V_ID = "error: " + @V_Cod + @V_Num.to_s #error: FRSxV.xxx
@msg = @V_ID + " - Rot Cycles must be > 0."
UI.messagebox(@msg); warn(@msg)
@Verification = "NOT OK"
end
@V_Num += 1

#5th verification
if (@Rot_Exp_Log > 32.0)
@V_ID = "error: " + @V_Cod + @V_Num.to_s #error: FRSxV.xxx
@msg = @V_ID + " - max. Exp/Log Factor = 32."
UI.messagebox(@msg); warn(@msg)
@Verification = "NOT OK"
end
@V_Num += 1

#6th verification
if (@Rot_Exp_Log < -32.0)
@V_ID = "error: " + @V_Cod + @V_Num.to_s #error: FRSxV.xxx
@msg = @V_ID + " - min. Exp/Log Factor = -32."
UI.messagebox(@msg); warn(@msg)
@Verification = "NOT OK"
end
@V_Num += 1



#7th verification
if (@Scale_Parameter > 100)
@V_ID = "error: " + @V_Cod + @V_Num.to_s #error: FRSxV.xxx
@msg = @V_ID + " - Scale parameter is too high. (max 100)"
UI.messagebox(@msg); warn(@msg)
@Verification = "NOT OK"
end
@V_Num += 1

#8th verification
if (@Scale_Parameter <= 0)
@V_ID = "error: " + @V_Cod + @V_Num.to_s #error: FRSxV.xxx
@msg = @V_ID + " - Scale parameter must be higher than 0."
UI.messagebox(@msg); warn(@msg)
@Verification = "NOT OK"
end
@V_Num += 1

#9th verification
if (@Sca_Cycles <= 0)
@V_ID = "error: " + @V_Cod + @V_Num.to_s #error: FRSxV.xxx
@msg = @V_ID + " - Sca Cycles must be > 0."
UI.messagebox(@msg); warn(@msg)
@Verification = "NOT OK"
end
@V_Num += 1

#11th verification
if (@Sca_Exp_Log > 32.0)
@V_ID = "error: " + @V_Cod + @V_Num.to_s #error: FRSxV.xxx
@msg = @V_ID + " - max. Exp/Log Factor = 32."
UI.messagebox(@msg); warn(@msg)
@Verification = "NOT OK"
end
@V_Num += 1

#12th verification
if (@Sca_Exp_Log < -32.0)
@V_ID = "error: " + @V_Cod + @V_Num.to_s #error: FRSxV.xxx
@msg = @V_ID + " - min. Exp/Log Factor = -32."
UI.messagebox(@msg); warn(@msg)
@Verification = "NOT OK"
end
@V_Num += 1


)
print("Verifications: " + @Verification.to_s + "\n\n")
#-------------------------------------------------------------------------------
end



#Conversions
@Section_Interval = @Section_Interval.to_f

#@Rotation_Parameter is already float radians or cycles
#@Rot_Phase is already float radians or cycles
@Rot_Cycles = @Rot_Cycles.to_f

@Rot_Exp_Log = @Rot_Exp_Log.to_f

@Scale_Parameter = @Scale_Parameter.to_f
#@Sca_Phase is already float radians or cycles
@Sca_Cycles = @Sca_Cycles.to_f

@Sca_Exp_Log = @Sca_Exp_Log.to_f



#Normalizing path segments based on section interval
@Path_Segments = Taxsola.normalize_segments2(@Path_Segments, @Section_Interval, @Rev_Segs)
print ("Path segments are normalized. Section interval: " + @Section_Interval.to_s)


(#PROJECT REPORT -------------------------------------------

@Profile_points_Ammount = 0
	@Profile_Segments.each do |segment|
		@Profile_points_Ammount += (segment.length)
	end
@Profile_edges = (@Profile_points_Ammount - @Profile_Segments.length)

@Sections_Ammount = 0
@Seg_Secs_Ammount = []
	@Path_Segments.each do |segment|
		@Sections_Ammount += (segment.length)
		@Seg_Secs_Ammount << (segment.length)
	end
@Path_edges = (@Sections_Ammount - @Path_Segments.length)

@Mesh_Pts = (@Profile_points_Ammount * @Sections_Ammount)
@Mesh_Tris = (@Profile_edges * @Path_edges * 2)


@details = ""
	for i in 1..(@Path_Segments.length)
		@SSA = @Seg_Secs_Ammount[i-1]

		@details += "Segment " + i.to_s + ": "
		@details += @SSA.to_s + " Sections | "
		@details += (@SSA*@Profile_points_Ammount).to_s + " Points | "
		@details += (@Profile_edges*(@SSA-1)*2).to_s + " Tris"
		@details += "\n"
	end


print("\n\n")

@msg = "REPORT:\n"
@msg += "Profile points: " + @Profile_points_Ammount.to_s
@msg += "\n" + "------------------------" + "\n"
@msg += @details
@msg += "------------------------" + "\n"
@msg += "Total sections: " + @Sections_Ammount.to_s + "\n"
@msg += "Total mesh points: " + @Mesh_Pts.to_s + "\n"
@msg += "Total mesh tris: " + @Mesh_Tris.to_s
print (@msg)

print("\n\n")
#----------------------------------------------------------
)


#Operation confirmation
@E_Time = (@Mesh_Tris/5000.0).round(2)
@msg = "Estimated time: " + @E_Time.to_s + "s (at 5k/s)"
print(@msg)
if UI.messagebox(@msg + "\n\nContinue?", type = MB_YESNO) != IDYES
	UI.messagebox("Follow Rotate Scale\nOperation has been aborted.", type = MB_OK)
	raise Exception.new("FRS - Operation has been aborted.")
end

#Speed boost by disable UI updates ---- <<<
model.start_operation('FRS - Mesh generation', true)

# TIMER ------------------------------------------------------------------------------------
@start_time = Time.now



#Sections properties definition
@Paths = []
@Path_Segments.each do |segment|
@Segment = []

#Segment mode definition
if (segment.first == segment.last) then @Mode = "Loop" else @Mode = "Open" end


for section in 0..(segment.length-1)
@Section = {}
@Section[:position] = segment[section]


@Last_Distance = Taxsola.distance(segment[segment.length-2], (segment[segment.length-1]))

if (@Last_Distance.to_f < @Section_Interval.to_f) #if last section isn't complete
	@Interval_Fraction = @Last_Distance.to_f / @Section_Interval.to_f
	@Seg_Ammount = (segment.length.to_f - 2.0) + @Interval_Fraction

	if (section == (segment.length-1))
		@Curr_Sec = @Seg_Ammount.to_f
	else
		@Curr_Sec = section
	end

else
	@Seg_Ammount = (segment.length-1.0).to_f
	@Curr_Sec = section
end



	#ROTATION definition
	case @Rotation_Interp
		when "Linear Interval"
			@Compass_Rotation = @Rotation_Parameter.to_f
			@Section[:rotation] = (@Compass_Rotation.to_f * @Curr_Sec.to_f) + @Rot_Phase

		when "Linear Total"
			@Compass_Rotation = (@Rotation_Parameter.to_f)/ @Seg_Ammount.to_f
			@Section[:rotation] = (@Compass_Rotation.to_f * @Curr_Sec.to_f) + @Rot_Phase

		when "Parabole"
			@Freq = 180.0.degrees / @Seg_Ammount
			@Angle = (@Freq.to_f * @Curr_Sec.to_f) + @Rot_Phase
			@Rot_Factor = Math.sin(@Angle.to_f)
			@Section[:rotation] = (@Rot_Factor * @Rotation_Parameter.to_f)

		when "SineWave-Cycles"
			@Angle = ((@Rot_Cycles.to_f/@Seg_Ammount.to_f) * @Curr_Sec.to_f * 360.0.degrees) + @Rot_Phase
			@Rot_Factor = Math.sin(@Angle).to_f
			@Section[:rotation] = (@Rot_Factor * @Rotation_Parameter.to_f)

		when "Exponential"
			@Exp = Taxsola.unitary_scale(0, @Curr_Sec, @Seg_Ammount) #From 0 to 1 scale
			@Exp *= 2.0
			@Section[:rotation] = (@Rot_Exp_Log**@Exp).to_f + @Rot_Phase

		when "Logarithm"
			@Exp = Taxsola.unitary_scale(0, @Curr_Sec, @Seg_Ammount) #From 0 to 1 scale
			@Exp *= 2.0
			@Section[:rotation] = (1.0/(@Rot_Exp_Log**@Exp).to_f) + @Rot_Phase

		else
			UI.messagebox("Error: Rotation interpolation not identifyed.")
			raise Exception.new("Error: Rotation interpolation not identifyed.")
	end



	#SCALE definition
	case @Scale_Interp
		when "Linear Total"
			@Compass_Scale = (@Scale_Parameter-1.0)/@Seg_Ammount
			@Section[:scale] = (@Compass_Scale * @Curr_Sec) + 1.0

		when "Parabole"
			@Freq = 180.0.degrees / @Seg_Ammount
			@Angle = (@Freq.to_f * @Curr_Sec.to_f) + @Sca_Phase
			@Scale_Factor = Math.sin(@Angle.to_f)
			@Section[:scale] = (@Scale_Factor * @Scale_Parameter.to_f) + 1.0

		when "SineWave-Cycles"
			@Angle = ((@Sca_Cycles.to_f/@Seg_Ammount.to_f) * @Curr_Sec.to_f * 360.0.degrees) + @Sca_Phase
			@Scale_Factor = (Math.sin(@Angle.to_f)+1.0)/2.0
			@Section[:scale] = (@Scale_Factor * @Scale_Parameter.to_f) + 1.0

		when "Exponential"
			@Exp = Taxsola.unitary_scale(0, @Curr_Sec, @Seg_Ammount) #From 0 to 1 scale
			@Exp *= 2.0
			@Section[:scale] = (@Sca_Exp_Log**@Exp).to_f

		when "Logarithm"
			@Exp = Taxsola.unitary_scale(0, @Curr_Sec, @Seg_Ammount) #From 0 to 1 scale
			@Exp *= 2.0
			@Section[:scale] = 1.0/(@Sca_Exp_Log**@Exp).to_f

		else
			UI.messagebox("Error: Scale interpolation not identifyed.")
			raise Exception.new("Error: Scale interpolation not identifyed.")
	end



	#NORMAL definition
	case section
		when 0 #First section
			if (@Mode == "Open")
				@Section[:normal] = Taxsola.find_normal(segment[0], segment[1], "") #First on open
			else
				@Section[:normal] = Taxsola.find_normal(segment[-2], segment[0], segment[1]) #First on loop
			end

		when (segment.length-1) #Last section
			if (@Mode == "Open")
				@Section[:normal] = Taxsola.find_normal(segment[-2], segment[section], "") #Last on open
			else
				@Section[:normal] = Taxsola.find_normal(segment[-2], segment[section], segment[1]) #Last on loop
			end

		else #Middle sections
			@Section[:normal] = Taxsola.find_normal(segment[section-1], segment[section], segment[section+1])
	end



@Segment << @Section
end

@Paths << @Segment
end

print("FRS: Sections properties defined.")


#AXES DEFINITION SELECTOR 0,1,2 / x,y,z / Normal, side, up
case @Flat_Axis
	when 0 #X is flat
		@X_ID = 0 #Normal
		@Y_ID = 1 #Side
		@Z_ID = 2 #Up

	when 1 #Y is flat
		@X_ID = 1 #Side
		@Y_ID = 0 #Normal
		@Z_ID = 2 #Up

	when 2 #Z is flat
		@X_ID = 1 #Side
		@Y_ID = 2 #Up
		@Z_ID = 0 #Normal
end


#Reverse tris diagonal
if (@Rotation_Parameter > 0) 
	if (@Invert_Tris == "No")
		@Tid1 = [0,2,1]
		@Tid2 = [1,2,3]
	else
		@Tid1 = [0,3,1]
		@Tid2 = [0,2,3]
	end
else
	if (@Invert_Tris == "No")
		@Tid1 = [0,3,1]
		@Tid2 = [0,2,3]
	else
		@Tid1 = [0,2,1]
		@Tid2 = [1,2,3]
	end
end



#SEGMENTS MESHES GENERATION
print("FRS: Starting mesh generation.")
@FRS_global = Sketchup.active_model.entities.add_group #Geral group
@Seg_ID = 0

@Paths.each do |seg|

if (@Paths.length > 1)
	@FRS = @FRS_global.entities.add_group #Sub groups in case there is more than 1 segment
else
	@FRS = @FRS_global
end

@pts = @Profile_points_Ammount * @Seg_Secs_Ammount[@Seg_ID]
@tris = (@Seg_Secs_Ammount[@Seg_ID]-1) * @Profile_edges * 2
@Seg_Mesh = Geom::PolygonMesh.new(@pts, @tris)

@Last_Up = Geom::Vector3d.new(0,0,1)

@Sec_ID = 0
	seg.each do |sec|

		@Current_Sec = []
		@Profile_Segments.each do |seg|
		@Seg = []
			seg.each do |pt|
				@Pt = pt.to_a
				@Seg << Geom::Point3d.new(@Pt[0], @Pt[1], @Pt[2])
			end
		@Current_Sec << @Seg
		end


		#Get section parameters
		@Sec_P = sec[:position]
		@Sec_N = sec[:normal].normalize
		@Sec_R = sec[:rotation]
		@Sec_S = sec[:scale]

		#Define new axe vectors
		if (@Sec_ID == 0) && ((@Sec_N == Z_AXIS) || (@Sec_N == Z_AXIS.reverse))
			@Last_Up = Geom::Vector3d.new(0,1,0) #Defult up in case 1st normal = Z_AXIS
		end



		case @Up_Ref
			when "Roll on"
				@Side_vec = (@Sec_N.cross(@Last_Up)).normalize
				@Up_vec = (@Sec_N.cross(@Side_vec)).normalize
				if ((@Up_vec.angle_between @Last_Up).radians > 90)
					@Up_vec.reverse!
					@Side_vec = (@Sec_N.cross(@Up_vec)).normalize
				end

			when "Truncate"
				if (@Sec_N == Z_AXIS) || (@Sec_N.reverse == Z_AXIS)
					@Side_vec = (@Sec_N.cross(@Last_Up)).normalize
					@Up_vec = (@Sec_N.cross(@Side_vec)).normalize #Up correction
				else
					@Up_vec = Taxsola.truncate_vector(@Last_Up)
					@Side_vec = (@Sec_N.cross(@Up_vec)).normalize
					@Up_vec = (@Sec_N.cross(@Side_vec)).normalize #Up correction
				end

				@Compare_Last = (@Up_vec.angle_between @Last_Up).radians
				if (@Compare_Last > 90 && (@Sec_ID != 0)) #Reverse vectors
					@Up_vec.reverse!
					@Side_vec.reverse!
				end

			when "Z-corrected"
				if (@Sec_N == Z_AXIS) || (@Sec_N.reverse == Z_AXIS)
					@Side_vec = (@Sec_N.cross(X_AXIS)).normalize
					@Up_vec = (@Sec_N.cross(@Side_vec)).normalize #Up correction
				else #edited in 24/12/2022 for 10.93 test
					@Side_vec = ( (Geom::Vector3d.new(@Sec_N[0], @Sec_N[1], 0).normalize).cross(Z_AXIS) ).normalize
					@Up_vec = ( (@Sec_N.normalize).cross(@Side_vec.normalize) ).normalize #Up correction
				end

				@Compare_Last = (@Up_vec.angle_between @Last_Up).radians
				if (@Compare_Last > 90 && (@Sec_ID != 0)) #Reverse vectors
					@Up_vec.reverse!
					@Side_vec.reverse!
				end

			when "Z-streched"
				if (@Sec_N == Z_AXIS) || (@Sec_N.reverse == Z_AXIS)
					@Side_vec = (@Sec_N.cross(X_AXIS)).normalize
					@Up_vec = (@Sec_N.cross(@Side_vec)).normalize #Up correction
				else #added in 24/12/2022 for 10.93 test
					@Side_vec = ( (Geom::Vector3d.new(@Sec_N[0], @Sec_N[1], 0).normalize).cross(Z_AXIS) ).normalize
					@Up_vec = Z_AXIS
				end

				@Compare_Last = (@Up_vec.angle_between @Last_Up).radians
				if (@Compare_Last > 90 && (@Sec_ID != 0)) #Reverse vectors
					@Up_vec.reverse!
					@Side_vec.reverse!
				end
		end

		@Last_Up = @Up_vec.clone



		#Define new axes on flat selector
		@New_Axes = [@Sec_N, @Side_vec, @Up_vec] # direction, side, up
		@newX = @New_Axes[@X_ID]
		@newY = @New_Axes[@Y_ID]
		@newZ = @New_Axes[@Z_ID]

		#Transformations definitions
		@Position_tr = Geom::Transformation.axes(@Sec_P, @newX, @newY, @newZ)
		@Rotation_tr = Geom::Transformation.rotation(@Sec_P, @Sec_N, @Sec_R)
		@Scale_tr = Geom::Transformation.scaling(@Sec_P, @Sec_S)


		#Section transformations
		for seg in 0..(@Current_Sec.length-1)
			for pt in 0..(@Current_Sec[seg].length-1)
				@Current_Sec[seg][pt].transform!(@Position_tr)
				@Current_Sec[seg][pt].transform!(@Rotation_tr)
				@Current_Sec[seg][pt].transform!(@Scale_tr)
			end
		end
		#------------------------------------------------------------------------------

		#GENERATE VIRTUAL FACES
		if (@Sec_ID > 0) #First section has no previous section to generate faces from
			for seg in 0..(@Current_Sec.length-1)
				for pt in 0..(@Current_Sec[seg].length-1)
					if pt == 0 then next end #Jump first point
					@PTS = []
					@PTS << @Current_Sec[seg][pt-1]
					@PTS << @Current_Sec[seg][pt]
					@PTS << @Last_Sec[seg][pt-1]
					@PTS << @Last_Sec[seg][pt]

					@f1 = @Seg_Mesh.add_polygon(@PTS[@Tid1[0]], @PTS[@Tid1[1]], @PTS[@Tid1[2]])#GENERATE VIRTUAL TRI FACE 1
					@f2 = @Seg_Mesh.add_polygon(@PTS[@Tid2[0]], @PTS[@Tid2[1]], @PTS[@Tid2[2]])#GENERATE VIRTUAL TRI FACE 2
				end
			end
		end


		#Last section to array points
		@Last_Sec = []
		@Current_Sec.each do |seg|
		@Seg = []
			seg.each do |pt|
				@Pt = pt.to_a
				@Seg << Geom::Point3d.new(@Pt[0], @Pt[1], @Pt[2])
			end
		@Last_Sec << @Seg
		end

		@Sec_ID += 1
	end #End of segment

@FRS.entities.fill_from_mesh(@Seg_Mesh, true, 4, nil) #Build segment mesh
@Seg_ID += 1
end



# TIMER END -------------------------------------------------------------------------
@end_time = Time.now
@Total_Time = @end_time - @start_time

Sketchup.active_model.commit_operation
#-------------------------------------- <<<

@msg = ""
@msg += "Sucess."
@msg += "\n\n"
@msg += @Mesh_Tris.to_s + " tris in " + @Total_Time.round(3).to_s + "s. (" + (@Mesh_Tris/@Total_Time).round(2).to_s + " t/s)"
print(@msg)
print("--------------------")
print("\n\n")
Taxsola.soundeffect(1) #0: Installation | 1: Success | 2: Notification
#------------------------------------------------------------------------------------
		end #end of FRS sub extension



	end #end of Tax_Engineering extensions
end #end of taxsola module