=begin
#-------------------------------
Author: Tax, 2021
Description:
#-------------------------------
=end


#-------------------------------------------------------------------------------
module Taxsola
	module Tax_Engineering

def self.su_links
dialog = UI::HtmlDialog.new({
  :dialog_title => "TAX - SU links",
  :preferences_key => "com.sample.plugin",
  :resizable => false,
  :style => UI::HtmlDialog::STYLE_DIALOG
})
(html = "<!DOCTYPE html>
<html>

	<head>
		"+@@HtmlDialog_Dependencies+"
		<script>function GoToUrl(url) {sketchup.OpenUrl(url);}</script>
	</head>



<body class='m-3 bg-panel-background'>

	<ul class='nav nav-tabs nav-tabs-sm' id='exampleTab' role='tablist'>
		<li class='nav-item'>
			<a class='nav-link active' id='tab1' data-toggle='tab' href='#ref_tab1' role='tab' aria-controls='ref_tab1' aria-selected='true'>Main</a>
		</li>

		<li class='nav-item'>
			<a class='nav-link' id='tab2' data-toggle='tab' href='#ref_tab2' role='tab' aria-controls='ref_tab2' aria-selected='false'>Devs</a>
		</li>

		<li class='nav-item'>
			<a class='nav-link' id='tab3' data-toggle='tab' href='#ref_tab3' role='tab' aria-controls='ref_tab3' aria-selected='false'>Others</a>
		</li>
	</ul>


	<div class='tab-content py-3' id='exampleTabContent'>

		<div class='tab-pane fade show active' id='ref_tab1' role='tabpanel' aria-labelledby='tab1'>
			<h5 id='tab1_content'>Main links:</h5>
				<a href='https://www.sketchup.com/' onclick='GoToUrl(href); return false;'>SU main page</a><br>
				<a href='https://help.sketchup.com/' onclick='GoToUrl(href); return false;'>Help center</a><br>
				<a href='https://support.sketchup.com/s/' onclick='GoToUrl(href); return false;'>Support</a><br>
				<a href='https://blog.sketchup.com/' onclick='GoToUrl(href); return false;'>SU blog</a><br>
				<a href='https://learn.sketchup.com/' onclick='GoToUrl(href); return false;'>Courses</a><br>
				<a href='https://status.sketchup.com/' onclick='GoToUrl(href); return false;'>SU web Status</a><br>

				<br><text>Users:</text><br>
				<a href='https://3dwarehouse.sketchup.com/' onclick='GoToUrl(href); return false;'>&emsp;3D warehouse</a><br>
				<a href='https://extensions.sketchup.com/' onclick='GoToUrl(href); return false;'>&emsp;Extension warehouse</a><br>
				<a href='https://sketchucation.com/pluginstore' onclick='GoToUrl(href); return false;'>&emsp;PluginStore</a><br>

				<br><text>Community:</text><br>
				<a href='https://forums.sketchup.com/' onclick='GoToUrl(href); return false;'>&emsp;SU Community</a><br>
				<a href='https://sketchucation.com/' onclick='GoToUrl(href); return false;'>&emsp;Sketchucation</a><br>
				<a href='https://www.youtube.com/user/SketchUpVideo' onclick='GoToUrl(href); return false;'>&emsp;SU YT channel</a><br>
				<a href='https://www.crowdcast.io/sketchup_official' onclick='GoToUrl(href); return false;'>&emsp;SU CrowdCast</a><br>
				<a href='https://www.reddit.com/r/Sketchup/' onclick='GoToUrl(href); return false;'>&emsp;SU Reddit</a><br>
				<a href='https://web.facebook.com/sketchup?_rdc=1&_rdr' onclick='GoToUrl(href); return false;'>&emsp;SU Facebook</a><br>
				<a href='https://www.instagram.com/sketchup_official' onclick='GoToUrl(href); return false;'>&emsp;SU Instagram</a><br>
				<a href='https://twitter.com/SketchUp' onclick='GoToUrl(href); return false;'>&emsp;SU Twitter</a><br>
				<a href='https://discord.com/invite/b6ejhRp' onclick='GoToUrl(href); return false;'>&emsp;SU Discord</a><br>
				<a href='https://www.pinterest.com/SketchUpTrimble/' onclick='GoToUrl(href); return false;'>&emsp;SU Pinterest</a><br>
				<a href='https://www.linkedin.com/company/sketchup/' onclick='GoToUrl(href); return false;'>&emsp;SU LinkedIn</a><br>
		</div>

		<div class='tab-pane fade' id='ref_tab2' role='tabpanel' aria-labelledby='tab2'>
			<h5 id='tab2_content'>Getting into it:</h5>
				<a href='https://developer.sketchup.com/' onclick='GoToUrl(href); return false;'>SU Devs page</a><br>
				<a href='https://developer.sketchup.com/developers/welcome' onclick='GoToUrl(href); return false;'>Be a dev</a><br>

				<br><text>Tutorials:</text><br>
				<a href='https://forums.sketchup.com/t/ruby-learning-resources-wikilists/22861' onclick='GoToUrl(href); return false;'>&emsp;Learning Resources</a><br>
				<a href='https://ruby-doc.org/docs/Tutorial/' onclick='GoToUrl(href); return false;'>&emsp;Introduction to Ruby</a><br>
				<a href='https://www.techotopia.com/index.php/Ruby_Essentials' onclick='GoToUrl(href); return false;'>&emsp;Ruby Essentials</a><br>
				<a href='http://rubylearning.com/satishtalim/tutorial.html' onclick='GoToUrl(href); return false;'>&emsp;Ruby Study Notes</a><br>
				<a href='https://www.regular-expressions.info/ruby.html' onclick='GoToUrl(href); return false;'>&emsp;Ruby Regular Expressions</a><br>
				<a href='http://sketchuptips.blogspot.com/2008/08/sketchup-ruby-api-class-diagrams.html' onclick='GoToUrl(href); return false;'>&emsp;API Class Diagrams</a><br>
				<a href='https://books.google.com.br/books?id=t-rGBwAAQBAJ&lpg=PA330&ots=pkSL0rXRpI&dq=RUBY%20SKETCHUP%20API%20CLASS%20%22DIAGRAM%22&pg=PA331#v=onepage&q=RUBY%20SKETCHUP%20API%20CLASS%20%22DIAGRAM%22&f=true' onclick='GoToUrl(href); return false;'>&emsp;API Objects Diagrams</a><br>

				<text>&emsp;Specific:</text><br>
				<a href='https://github.com/thomthom/sketchup-webdialogs-the-lost-manual/wiki' onclick='GoToUrl(href); return false;'>&emsp;&emsp;Web dialogs</a><br>
				<a href='https://github.com/SketchUp/htmldialog-examples' onclick='GoToUrl(href); return false;'>&emsp;&emsp;Html dialogs</a><br>

				<br><text>Examples:</text><br>
				<a href='https://github.com/SketchUp/sketchup-ruby-api-tutorials/tree/master/tutorials' onclick='GoToUrl(href); return false;'>&emsp;Commented examples</a><br>
				<a href='https://github.com/SketchUp/sketchup-ruby-api-tutorials/tree/master/examples' onclick='GoToUrl(href); return false;'>&emsp;Non commented examples</a><br>
				<a href='https://forums.sketchup.com/t/extension-example-count-material-area/56332' onclick='GoToUrl(href); return false;'>&emsp;Count material area</a><br>
				<a href='https://github.com/SketchUp/ruby-c-extension-examples' onclick='GoToUrl(href); return false;'>&emsp;C examples</a><br>
				<a href='https://forums.sketchup.com/t/template-multi-file-multi-class-with-sharedconstants-mixin/24639' onclick='GoToUrl(href); return false;'>&emsp;Multi-File Template</a><br>

				<br><text>Snippets:</text><br>
				<a href='https://sketchucation.com/forums/viewtopic.php?f=180&t=28846' onclick='GoToUrl(href); return false;'>&emsp;Snippets 1</a><br>
				<a href='https://forums.sketchup.com/search?q=snippet' onclick='GoToUrl(href); return false;'>&emsp;Snippets 2</a><br>


				<br><text>--------------------</text><br>
				
				<br><text>Base docs:</text><br>
				<a href='https://ruby.sketchup.com/' onclick='GoToUrl(href); return false;'>&emsp;Ruby API docs</a><br>
				<a href='https://ruby-doc.org/' onclick='GoToUrl(href); return false;'>&emsp;Ruby docs</a><br>
				<a href='https://extensions.sketchup.com/developers/sketchup_c_api/sketchup/index.html' onclick='GoToUrl(href); return false;'>&emsp;C API docs</a><br>
				<a href='https://devdocs.io/c/' onclick='GoToUrl(href); return false;'>&emsp;C docs</a><br>

				<br><text>UX Guidelines:</text><br>
				<a href='https://sketchup.github.io/sketchup-extension-ux-guidelines/' onclick='GoToUrl(href); return false;'>&emsp;UX Guidelines</a><br>
				
				<br><text>UI Guidelines:</text><br>
				<a href='https://sketchup.github.io/modus-for-sketchup-extensions/' onclick='GoToUrl(href); return false;'>&emsp;Modus (github)</a><br>
				<a href='https://modus-bootstrap.trimble.com/' onclick='GoToUrl(href); return false;'>&emsp;Modus (bootstrap)</a><br>
				<a href='https://modus.trimble.com/developers/' onclick='GoToUrl(href); return false;'>&emsp;Modus (developers)</a><br>
				<a href='https://modus.trimble.com/designers/' onclick='GoToUrl(href); return false;'>&emsp;Modus (designers)</a><br>
				<a href='https://modus.trimble.com/sketch/' onclick='GoToUrl(href); return false;'>&emsp;Modus (UI maker)</a><br>
				
				<br><a href='https://myprofile.trimble.com/' onclick='GoToUrl(href); return false;'>&emsp;Trimble login</a><br>
				
				<br><text>--------------------</text><br>

				<br><text>Improving:</text><br>
				<a href='https://github.com/SketchUp/rubocop-sketchup' onclick='GoToUrl(href); return false;'>&emsp;RuboCop</a><br>
				<a href='https://github.com/SketchUp/speedup' onclick='GoToUrl(href); return false;'>&emsp;SpeedUp</a><br>
				
				<br><text>Support:</text><br>
				<a href='https://github.com/SketchUp/api-issue-tracker' onclick='GoToUrl(href); return false;'>&emsp;Issue tracker (GitHub)</a><br>
				<a href='mailto:developer-support@sketchup.com' onclick='GoToUrl(href); return false;'>&emsp;E-mail: developer-support@sketchup.com</a><br>
		</div>

		<div class='tab-pane fade' id='ref_tab3' role='tabpanel' aria-labelledby='tab3'>
			<h5 id='tab3_content'>YouTube channels:</h5>
				<a href='https://www.youtube.com/c/SketchUpSchool' onclick='GoToUrl(href); return false;'>SketchUp School</a><br>
				<a href='https://www.youtube.com/c/Thesketchupessentials' onclick='GoToUrl(href); return false;'>TheSketchUpEssentials</a><br>

				<br><text>Countries:</text><br>
				<a href='https://www.youtube.com/c/SketchUpUK' onclick='GoToUrl(href); return false;'>&emsp;UK & IE</a><br>
				<a href='https://www.youtube.com/channel/UC61kwtq-SIiP8ljHuaf882Q' onclick='GoToUrl(href); return false;'>&emsp;Australia</a><br>
				<a href='https://www.youtube.com/c/SketchUpFrance' onclick='GoToUrl(href); return false;'>&emsp;France</a><br>
				<a href='https://www.youtube.com/channel/UC_ELM-Zydq7-vBl_fQ4IrVQ' onclick='GoToUrl(href); return false;'>&emsp;Brasil</a><br>
				<a href='https://www.youtube.com/channel/UCjIvQ8nTgcY9vhAZQbT-Q7w' onclick='GoToUrl(href); return false;'>&emsp;Latvia</a><br>
				<a href='https://www.youtube.com/channel/UCHb-qdl7neRYP_n-8qt0lqw' onclick='GoToUrl(href); return false;'>&emsp;Czechia</a><br><br>
		</div>

	</div>

</body>

</html>
")

dialog.set_html(html)
dialog.set_size(280, 660)
dialog.show

#Open Url on external browser
dialog.add_action_callback("OpenUrl"){|action_context, url| UI.openURL(url.to_s) }
end



	end #end of extension space
end #end of Taxsola's space