=begin
#-------------------------------
Author: Tax, 2022
Description: Edge Groups
#-------------------------------
=end


#-------------------------------------------------------------------------------
module Taxsola
	module Tax_Engineering

def self.edge_groups

dialog = UI::HtmlDialog.new({
  :dialog_title => "TAX - Edge groups",
  :preferences_key => "com.sample.plugin",
  :resizable => false,
  :style => UI::HtmlDialog::STYLE_DIALOG
})
(html = "<!DOCTYPE html>
<html>

	<head>
			"+@@HtmlDialog_Dependencies+"
		
		<script>function Assign(num) {sketchup.Assign(num); document.getElementById(num.toString()).setAttribute('class', 'badge badge-pill badge-warning');}</script>
		<script>function Select(num) {sketchup.Select(num);}</script>
		<script>function Clear(num) {sketchup.Clear(num); document.getElementById(num.toString()).setAttribute('class', 'badge badge-pill badge-dark');}</script>
	</head>

	<body class='m-3 bg-panel-background'>
		<div>
			<span id='1' class='badge badge-pill badge-dark'>1</span>
			<button id='a1' type='button' class='btn btn-sm btn-primary' onclick='Assign(1)'>Assign </button>
			<button id='s1' type='button' class='btn btn-sm btn-secondary' onclick='Select(1)'>Select</button>
			<button id='c1' type='button' class='btn btn-sm btn-danger' onclick='Clear(1)'>Clear</button>
		</div>

		<div>
			<span id='2' class='badge badge-pill badge-dark'>2</span>
			<button id='a2' type='button' class='btn btn-sm btn-primary' onclick='Assign(2)'>Assign </button>
			<button id='s2' type='button' class='btn btn-sm btn-secondary' onclick='Select(2)'>Select</button>
			<button id='c2' type='button' class='btn btn-sm btn-danger' onclick='Clear(2)'>Clear</button>
		</div>

		<div>
			<span id='3' class='badge badge-pill badge-dark'>3</span>
			<button id='a3' type='button' class='btn btn-sm btn-primary' onclick='Assign(3)'>Assign </button>
			<button id='s3' type='button' class='btn btn-sm btn-secondary' onclick='Select(3)'>Select</button>
			<button id='c3' type='button' class='btn btn-sm btn-danger' onclick='Clear(3)'>Clear</button>
		</div>

		<div>
			<span id='4' class='badge badge-pill badge-dark'>4</span>
			<button id='a4' type='button' class='btn btn-sm btn-primary' onclick='Assign(4)'>Assign </button>
			<button id='s4' type='button' class='btn btn-sm btn-secondary' onclick='Select(4)'>Select</button>
			<button id='c4' type='button' class='btn btn-sm btn-danger' onclick='Clear(4)'>Clear</button>
		</div>

		<div>
			<span id='5' class='badge badge-pill badge-dark'>5</span>
			<button id='a5' type='button' class='btn btn-sm btn-primary' onclick='Assign(5)'>Assign </button>
			<button id='s5' type='button' class='btn btn-sm btn-secondary' onclick='Select(5)'>Select</button>
			<button id='c5' type='button' class='btn btn-sm btn-danger' onclick='Clear(5)'>Clear</button>
		</div>
  </body>

</html>

")

dialog.set_html(html)
dialog.set_size(240, 200)
dialog.show


#VARIABLES
@Group_1 = []
@Group_2 = []
@Group_3 = []
@Group_4 = []
@Group_5 = []


#Assign
dialog.add_action_callback("Assign"){|action_context, num|
	@model = Sketchup.active_model
	@selection = @model.selection.to_a
	@selection = @selection.grep(Sketchup::Edge)

	case num.to_s
		when "1"
			@Group_1 += @selection
			@Group_1.uniq!
			puts "Group1 = " + @Group_1.to_s
			
		when "2"
			@Group_2 += @selection
			@Group_2.uniq!
			puts "Group2 = " + @Group_2.to_s

		when "3"
			@Group_3 += @selection
			@Group_3.uniq!
			puts "Group3 = " + @Group_3.to_s

		when "4"
			@Group_4 += @selection
			@Group_4.uniq!
			puts "Group4 = " + @Group_4.to_s

		when "5"
			@Group_5 += @selection
			@Group_5.uniq!
			puts "Group5 = " + @Group_5.to_s

		else
			puts("error: dialog ID not recognized.")
			puts num
	end
	
Taxsola.soundeffect(1) #0: Installation | 1: Success | 2: Notification
}

#Select
dialog.add_action_callback("Select"){|action_context, num|
	@model = Sketchup.active_model
	@selection = @model.selection
	
	case num.to_s
		when "1"
			@selection.add @Group_1

		when "2"
			@selection.add @Group_2

		when "3"
			@selection.add @Group_3

		when "4"
			@selection.add @Group_4

		when "5"
			@selection.add @Group_5

		else
			puts("error: dialog ID not recognized.")
			puts num
	end

Taxsola.soundeffect(1) #0: Installation | 1: Success | 2: Notification
}

#Clear
dialog.add_action_callback("Clear"){|action_context, num|
	case num.to_s
		when "1"
			@Group_1.clear
			puts "Group1 = " + @Group_1.to_s
			
		when "2"
			@Group_2.clear
			puts "Group2 = " + @Group_2.to_s

		when "3"
			@Group_3.clear
			puts "Group3 = " + @Group_3.to_s

		when "4"
			@Group_4.clear
			puts "Group4 = " + @Group_4.to_s

		when "5"
			@Group_5.clear
			puts "Group5 = " + @Group_5.to_s

		else
			puts("error: dialog ID not recognized.")
			puts num
	end

Taxsola.soundeffect(1) #0: Installation | 1: Success | 2: Notification
}

end

	end #end of extension space
end #end of Taxsola's space