=begin
#-------------------------------
Author: Tax, 2021
Description:
#-------------------------------
=end


#-------------------------------------------------------------------------------
module Taxsola
	module Tax_Engineering

		class Selection_Report_Observer < Sketchup::SelectionObserver
			def onSelectionBulkChange(selection)

				#model = Sketchup.active_model
				#entities = model.active_entities
				@Selection = selection #model.selection.to_a #Selection to array

				@Points = @Selection.grep(Sketchup::ConstructionPoint)
				@Edges = @Selection.grep(Sketchup::Edge)
				@Faces = @Selection.grep(Sketchup::Face)
				@Groups = @Selection.grep(Sketchup::Group)
				@Components = @Selection.grep(Sketchup::ComponentInstance)
				@Sections = @Selection.grep(Sketchup::SectionPlane)

				@msg = ""
				@msg += "Points: " + @Points.length.to_s + " | "
				@msg += "Edges: " + @Edges.length.to_s + " | "
				@msg += "Faces: " + @Faces.length.to_s + " | "
				@msg += "Groups: " + @Groups.length.to_s + " | "
				@msg += "Components: " + @Components.length.to_s + " | "
				@msg += "Sections: " + @Sections.length.to_s

				#Sketchup::set_status_text(@msg)
				Tax_Engineering.setting_note(@msg)
				Sketchup.active_model.active_view.refresh
			end
		end

		def self.report_dialog

			@SR_Menu_Counter += 1

			if (@SR_Menu_Counter%2 == 0)
				#Attach the observer.
				@@SR_note = Sketchup.active_model.add_note "Selection Report: n/a", 0.01, 0.04
				@SRO = Selection_Report_Observer.new
				Sketchup.active_model.selection.add_observer(@SRO)
				print "Selection report is now enabled."
				Taxsola.soundeffect(1) #0: Installation | 1: Success | 2: Notification
			else
				#Remove observer.
				Sketchup.active_model.selection.remove_observer(@SRO)
				@@SR_note.erase!
				print "Selection report is now disabled."
				Taxsola.soundeffect(1) #0: Installation | 1: Success | 2: Notification
			end
		end

		def self.setting_note(text)
			@@SR_note.set_text (text)
		end

	end
end
#-------------------------------------------------------------------------------