=begin
#-------------------------------
Author: Tax, 2021
Description:
#-------------------------------
=end


#-------------------------------------------------------------------------------
module Taxsola
	module Tax_Engineering
		def self.alarm_dialog
			
			#CHECK IF VRAY HAS BEEN LAUNCHED/STARTED ALREADY. OTHERWISE IT WOULD GIVE A BUGSPLAT
			if (Object::VRay::LiveScene::INSTANCES.count == 0)
				@msg = "V-ray hasn't been launched yet."
				print @msg
				UI.messagebox(@msg, type = MB_OK)
				raise Exception.new(@msg)
			end
			
			
			if @Alarm_State == "free"
			
				if VRay::LiveScene.active.rendering?

					@Alarm_State = "busy"
					print "--------------------------"
					print Time.now.to_s
					print "V-ray alarm: Timer start."
					
					@Settings_data = Taxsola.check_settings() #Get register settings
					@sound = @Settings_data['vray_alarm_sound']
					
					@Timer = UI.start_timer(5,true) {

						if !VRay::LiveScene.active.rendering?

							print "V-ray alarm check: Render is complete."
							print Time.now.to_s
							print "--------------------------"
							
							if (@sound == "")
								Taxsola.soundeffect(3) #Plays default vray alarm path
							else
								UI.play_sound(@sound) #Plays registered vray alarm path
							end
							
							@Alarm_State = "free"

							UI.stop_timer(@Timer)
							break
						end

					print "V-ray alarm check: still rendering."
					}

					UI.messagebox("V-ray alarm activated.\nMake sure your audio is on.", type = MB_OK)
					
				else
					@msg = "Render hasn't started. Try again."
					print "V-ray alarm: " + @msg
					UI.messagebox(@msg, type = MB_OK)
				end

			end
		end
	end
end
#-------------------------------------------------------------------------------